import { PropertyEditorDataSource as PropertyEditorDataSource_internal } from "./PropertyEditorDataSource";
export class IgrPropertyEditorDataSource {
    createImplementation() {
        return new PropertyEditorDataSource_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get descriptionType() {
        return this.i.n;
    }
    set descriptionType(v) {
        this.i.n = v;
    }
    get context() {
        return this.i.b;
    }
    set context(v) {
        this.i.b = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
