import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from "./PropertyEditorDescriptionObject";
import { PropertyEditorPropertyDescriptionCollection as PropertyEditorPropertyDescriptionCollection_internal } from "./PropertyEditorPropertyDescriptionCollection";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
export class IgrPropertyEditorDescriptionObject {
    createImplementation() {
        return new PropertyEditorDescriptionObject_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._properties = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get descriptionType() {
        return this.i.b;
    }
    set descriptionType(v) {
        this.i.b = v;
    }
    get properties() {
        if (this._properties === null) {
            let coll = new IgrPropertyEditorPropertyDescriptionCollection();
            let innerColl = this.i.a;
            if (!innerColl) {
                innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
            }
            this._properties = coll._fromInner(innerColl);
            this.i.a = innerColl;
        }
        return this._properties;
    }
    set properties(v) {
        if (this._properties !== null) {
            this._properties._setSyncTarget(null);
            this._properties = null;
        }
        let coll = new IgrPropertyEditorPropertyDescriptionCollection();
        this._properties = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PropertyEditorPropertyDescription.$type);
        let innerColl = this.i.a;
        if (!innerColl) {
            innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._properties._setSyncTarget(syncColl);
        this.i.a = innerColl;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.properties != null && this.properties.findByName && this.properties.findByName(name)) {
            return this.properties.findByName(name);
        }
        return null;
    }
}
