import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { ensureBool, brushToString, stringToBrush } from "igniteui-react-core";
export class IgrToolActionCheckbox extends IgrToolAction {
    createImplementation() {
        return new ToolActionCheckbox();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets if the tool action is checked.
    */
    get isChecked() {
        return this.i.hb;
    }
    set isChecked(v) {
        this.i.hb = ensureBool(v);
    }
    /**
     * Gets or sets the background color of the checkbox when in the unchecked state.
    */
    get uncheckedBackgroundColor() {
        return brushToString(this.i.h1);
    }
    set uncheckedBackgroundColor(v) {
        this.i.h1 = stringToBrush(v);
    }
    /**
     * Gets the actual background color of the checkbox when in the unchecked state.
    */
    get actualUncheckedBackgroundColor() {
        return brushToString(this.i.hx);
    }
    set actualUncheckedBackgroundColor(v) {
        this.i.hx = stringToBrush(v);
    }
    /**
     * Gets or sets the background color of the checkbox when in the checked state.
    */
    get checkedBackgroundColor() {
        return brushToString(this.i.hz);
    }
    set checkedBackgroundColor(v) {
        this.i.hz = stringToBrush(v);
    }
    /**
     * Gets the actual background color of the checkbox when in the checked state.
    */
    get actualCheckedBackgroundColor() {
        return brushToString(this.i.hv);
    }
    set actualCheckedBackgroundColor(v) {
        this.i.hv = stringToBrush(v);
    }
    /**
     * Gets or sets the border color of the checkbox when in the unchecked state.
    */
    get uncheckedBorderColor() {
        return brushToString(this.i.h2);
    }
    set uncheckedBorderColor(v) {
        this.i.h2 = stringToBrush(v);
    }
    /**
     * Gets the actual border color of the checkbox when in the unchecked state.
    */
    get actualUncheckedBorderColor() {
        return brushToString(this.i.hy);
    }
    set actualUncheckedBorderColor(v) {
        this.i.hy = stringToBrush(v);
    }
    /**
     * Gets or sets the border color of the checkbox when in the checked state.
    */
    get checkedBorderColor() {
        return brushToString(this.i.h0);
    }
    set checkedBorderColor(v) {
        this.i.h0 = stringToBrush(v);
    }
    /**
     * Gets the actual border color of the checkbox when in the checked state.
    */
    get actualCheckedBorderColor() {
        return brushToString(this.i.hw);
    }
    set actualCheckedBorderColor(v) {
        this.i.hw = stringToBrush(v);
    }
}
