import { ToolActionType_$type } from "igniteui-react-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from "./ToolActionEventDetail";
import { ensureEnum, ensureBool } from "igniteui-react-core";
export class IgrToolActionEventDetail {
    createImplementation() {
        return new ToolActionEventDetail_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get actionId() {
        return this.i.g;
    }
    set actionId(v) {
        this.i.g = v;
    }
    get actionType() {
        return this.i.a;
    }
    set actionType(v) {
        this.i.a = ensureEnum(ToolActionType_$type, v);
    }
    get isModified() {
        return this.i.c;
    }
    set isModified(v) {
        this.i.c = ensureBool(v);
    }
    get boolValue() {
        return this.i.b;
    }
    set boolValue(v) {
        this.i.b = ensureBool(v);
    }
    get numberValue() {
        return this.i.e;
    }
    set numberValue(v) {
        this.i.e = +v;
    }
    get dateTimeValue() {
        return this.i.d;
    }
    set dateTimeValue(v) {
        this.i.d = v;
    }
    get untypedValue() {
        return this.i.f;
    }
    set untypedValue(v) {
        this.i.f = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
