import { IgrToolActionEventDetail } from "./igr-tool-action-event-detail";
import { IgrToolActionEventDetailCollection } from "./igr-tool-action-event-detail-collection";
import { ToolActionPerformedEventArgs as ToolActionPerformedEventArgs_internal } from "./ToolActionPerformedEventArgs";
import { ensureBool } from "igniteui-react-core";
import { ToolActionEventDetailCollection as ToolActionEventDetailCollection_internal } from "./ToolActionEventDetailCollection";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
export class IgrToolActionPerformedEventArgs {
    createImplementation() {
        return new ToolActionPerformedEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._detailCollection = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get isAggregate() {
        return this.i.c;
    }
    set isAggregate(v) {
        this.i.c = ensureBool(v);
    }
    get detail() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrToolActionEventDetail();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set detail(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get detailCollection() {
        if (this._detailCollection === null) {
            let coll = new IgrToolActionEventDetailCollection();
            let innerColl = this.i.b;
            if (!innerColl) {
                innerColl = new ToolActionEventDetailCollection_internal();
            }
            this._detailCollection = coll._fromInner(innerColl);
            this.i.b = innerColl;
        }
        return this._detailCollection;
    }
    set detailCollection(v) {
        if (this._detailCollection !== null) {
            this._detailCollection._setSyncTarget(null);
            this._detailCollection = null;
        }
        let coll = new IgrToolActionEventDetailCollection();
        this._detailCollection = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(ToolActionEventDetail.$type);
        let innerColl = this.i.b;
        if (!innerColl) {
            innerColl = new ToolActionEventDetailCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._detailCollection._setSyncTarget(syncColl);
        this.i.b = innerColl;
    }
}
