import { IgrToolAction } from "./igr-tool-action";
import { ToolActionSeparator } from "./ToolActionSeparator";
import { ensureBool } from "igniteui-react-core";
export class IgrToolActionSeparator extends IgrToolAction {
    createImplementation() {
        return new ToolActionSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the size of the separator.
    */
    get size() {
        return this.i.hd;
    }
    set size(v) {
        this.i.hd = +v;
    }
    /**
     * Gets or sets whether to use group header styling or regular styling on this separator.
    */
    get isGroupHeaderSeparator() {
        return this.i.hb;
    }
    set isGroupHeaderSeparator(v) {
        this.i.hb = ensureBool(v);
    }
}
