/**
 * A primary key value.
*/
var IgrLayoutPrimaryKeyValue = /** @class */ /*@__PURE__*/ (function () {
    function IgrLayoutPrimaryKeyValue() {
        this.mounted = false;
    }
    Object.defineProperty(IgrLayoutPrimaryKeyValue.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrLayoutPrimaryKeyValue.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrLayoutPrimaryKeyValue.prototype.onImplementationCreated = function () {
    };
    IgrLayoutPrimaryKeyValue.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrLayoutPrimaryKeyValue.prototype, "key", {
        /**
         * The primary key associated with this value.
        */
        get: function () {
            return this.i.key;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.key = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrLayoutPrimaryKeyValue.prototype, "value", {
        /**
         * The value of the keys for this primary key value.
        */
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.value = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrLayoutPrimaryKeyValue.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    /**
     * Determines if two primary key values are equal.
    
    * @param other  * The other key value to check against.
    */
    IgrLayoutPrimaryKeyValue.prototype.equals = function (other) {
        var iv = this.i.equals(other);
        return (iv);
    };
    return IgrLayoutPrimaryKeyValue;
}());
export { IgrLayoutPrimaryKeyValue };
