import { __extends, __values } from "tslib";
import * as React from 'react';
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer } from "igniteui-react-core";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { ListPanel } from './ListPanel';
import { IgrListPanelTemplateItemUpdatingEventArgs } from './igr-list-panel-template-item-updating-event-args';
import { ListPanelOrientation_$type } from './ListPanelOrientation';
import { IgrListPanelContentRefreshedEventArgs } from './igr-list-panel-content-refreshed-event-args';
import { IgrListPanelTemplateWidthRequestedEventArgs } from './igr-list-panel-template-width-requested-event-args';
import { IgrListPanelTemplateHeightRequestedEventArgs } from './igr-list-panel-template-height-requested-event-args';
import { LocalDataSource } from "igniteui-react-core";
var IgrListPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrListPanel, _super);
    function IgrListPanel(props) {
        var _this = _super.call(this, props) || this;
        _this._implementation = null;
        _this._reactRenderer = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._contentRefreshed = null;
        _this._contentRefreshed_wrapped = null;
        _this._rowUpdating = null;
        _this._rowUpdating_wrapped = null;
        _this._itemWidthRequested = null;
        _this._itemWidthRequested_wrapped = null;
        _this._itemHeightRequested = null;
        _this._itemHeightRequested_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._getMainRef = _this._getMainRef.bind(_this);
        //var multiColumnComboBox = this.i;
        //multiColumnComboBox.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        _this._initialized = true;
        return _this;
    }
    IgrListPanel.prototype.createLocalDataSource = function (itemsSource, schemaIncludedProperties) {
        var lds = new LocalDataSource();
        lds.schemaIncludedProperties = schemaIncludedProperties;
        lds.dataSource = itemsSource;
        return lds;
    };
    IgrListPanel.prototype.onContentSizeChanged = function () {
    };
    Object.defineProperty(IgrListPanel.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this.i.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this.i.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype._getMainRef = function (ref) {
        this._elRef = ref;
        this.verifyReferences();
    };
    IgrListPanel.prototype.render = function () {
        var div = React.createElement("div", {
            ref: this._getMainRef,
            className: "ig-list-panel igr-list-panel",
        });
        return div;
    };
    IgrListPanel.prototype.verifyReferences = function () {
        var _this = this;
        if (this._elRef) {
            this._reactRenderer = new ReactRenderer(this._elRef, document, true, {});
            if (document) {
                this._elRef.style.display = "block";
                this._elRef.style.width = "100%";
                this._elRef.style.height = "100%";
            }
            // render needs to fire again after the portalManager is created. 
            this.i.provideContainer(this._reactRenderer);
            this.i.notifySizeChanged();
            this._reactRenderer.addSizeWatcher(function () {
                _this.i.notifySizeChanged();
            });
        }
    };
    IgrListPanel.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrListPanel.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrListPanel.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrListPanel.prototype.componentWillUnmount = function () {
        this.i.destroy();
        if (this._reactRenderer)
            this._reactRenderer.destroy();
    };
    IgrListPanel.prototype.componentDidMount = function () {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this.i.notifySizeChanged();
        this.initializeContent();
    };
    IgrListPanel.prototype.initializeContent = function () {
        this._styling(this._elRef, this);
        this.updateStyle();
        this.i.notifySizeChanged();
    };
    IgrListPanel.prototype.createImplementation = function () {
        return new ListPanel();
    };
    Object.defineProperty(IgrListPanel.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "rowHeight", {
        /**
     * Gets or Sets the property name that contains the values.
    */
        get: function () {
            return this.i.a9;
        },
        set: function (v) {
            this.i.a9 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "actualRowHeight", {
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "cellTextStyle", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: function () {
            if (this.i.s == null) {
                return null;
            }
            return this.i.s.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.s = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "hasUnevenSizes", {
        get: function () {
            return this.i.ah;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return brushToString(this.i.cx);
        },
        set: function (v) {
            this.i.cx = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "orientation", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureEnum(ListPanelOrientation_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "isCustomRowHeightEnabled", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the component.
        */
        get: function () {
            return brushToString(this.i.c0);
        },
        set: function (v) {
            this.i.c0 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgrListPanel.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrListPanel.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ListPanel");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Gets the last visible index in the grid.

*/
    IgrListPanel.prototype.getLastVisibleIndex = function () {
        var iv = this.i.a6();
        return (iv);
    };
    /**
     * Gets the first visible index in the grid.
    
    */
    IgrListPanel.prototype.getFirstVisibleIndex = function () {
        var iv = this.i.a5();
        return (iv);
    };
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    IgrListPanel.prototype.invalidateVisibleItems = function () {
        this.i.b3();
    };
    IgrListPanel.prototype.notifySetItem = function (index, oldItem, newItem) {
        this.i.b9(index, oldItem, newItem);
    };
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    IgrListPanel.prototype.notifyClearItems = function () {
        this.i.b6();
    };
    IgrListPanel.prototype.notifyInsertItem = function (index, newItem) {
        this.i.b7(index, newItem);
    };
    IgrListPanel.prototype.notifyRemoveItem = function (index, oldItem) {
        this.i.b8(index, oldItem);
    };
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    IgrListPanel.prototype.dataIndexOfItem = function (item) {
        var iv = this.i.a3(item);
        return (iv);
    };
    IgrListPanel.prototype.dataIndexOfPrimaryKey = function (key) {
        var iv = this.i.a4(key);
        return (iv);
    };
    IgrListPanel.prototype.exportVisualData = function () {
        var iv = this.i.bc();
        return (iv);
    };
    IgrListPanel.prototype.exportSerializedVisualData = function () {
        var iv = this.i.bj();
        return (iv);
    };
    Object.defineProperty(IgrListPanel.prototype, "contentRefreshed", {
        get: function () {
            return this._contentRefreshed;
        },
        set: function (ev) {
            var _this = this;
            if (this._contentRefreshed_wrapped !== null) {
                this.i.contentRefreshed = delegateRemove(this.i.contentRefreshed, this._contentRefreshed_wrapped);
                this._contentRefreshed_wrapped = null;
                this._contentRefreshed = null;
            }
            this._contentRefreshed = ev;
            this._contentRefreshed_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelContentRefreshedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeContentRefreshed) {
                    _this.beforeContentRefreshed(_this, outerArgs);
                }
                if (_this._contentRefreshed) {
                    _this._contentRefreshed(_this, outerArgs);
                }
            };
            this.i.contentRefreshed = delegateCombine(this.i.contentRefreshed, this._contentRefreshed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "rowUpdating", {
        get: function () {
            return this._rowUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._rowUpdating_wrapped !== null) {
                this.i.rowUpdating = delegateRemove(this.i.rowUpdating, this._rowUpdating_wrapped);
                this._rowUpdating_wrapped = null;
                this._rowUpdating = null;
            }
            this._rowUpdating = ev;
            this._rowUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateItemUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRowUpdating) {
                    _this.beforeRowUpdating(_this, outerArgs);
                }
                if (_this._rowUpdating) {
                    _this._rowUpdating(_this, outerArgs);
                }
            };
            this.i.rowUpdating = delegateCombine(this.i.rowUpdating, this._rowUpdating_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "itemWidthRequested", {
        get: function () {
            return this._itemWidthRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemWidthRequested_wrapped !== null) {
                this.i.itemWidthRequested = delegateRemove(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
                this._itemWidthRequested_wrapped = null;
                this._itemWidthRequested = null;
            }
            this._itemWidthRequested = ev;
            this._itemWidthRequested_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateWidthRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemWidthRequested) {
                    _this.beforeItemWidthRequested(_this, outerArgs);
                }
                if (_this._itemWidthRequested) {
                    _this._itemWidthRequested(_this, outerArgs);
                }
            };
            this.i.itemWidthRequested = delegateCombine(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "itemHeightRequested", {
        get: function () {
            return this._itemHeightRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemHeightRequested_wrapped !== null) {
                this.i.itemHeightRequested = delegateRemove(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
                this._itemHeightRequested_wrapped = null;
                this._itemHeightRequested = null;
            }
            this._itemHeightRequested = ev;
            this._itemHeightRequested_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateHeightRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemHeightRequested) {
                    _this.beforeItemHeightRequested(_this, outerArgs);
                }
                if (_this._itemHeightRequested) {
                    _this._itemHeightRequested(_this, outerArgs);
                }
            };
            this.i.itemHeightRequested = delegateCombine(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrListPanel;
}(React.Component));
export { IgrListPanel };
