import { PropertyEditorDataSource as PropertyEditorDataSource_internal } from "./PropertyEditorDataSource";
var IgrPropertyEditorDataSource = /** @class */ /*@__PURE__*/ (function () {
    function IgrPropertyEditorDataSource() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPropertyEditorDataSource.prototype.createImplementation = function () {
        return new PropertyEditorDataSource_internal();
    };
    Object.defineProperty(IgrPropertyEditorDataSource.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorDataSource.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorDataSource.prototype.onImplementationCreated = function () {
    };
    IgrPropertyEditorDataSource.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPropertyEditorDataSource.prototype, "descriptionType", {
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorDataSource.prototype, "context", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorDataSource.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrPropertyEditorDataSource;
}());
export { IgrPropertyEditorDataSource };
