import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from "./PropertyEditorDescriptionObject";
import { PropertyEditorPropertyDescriptionCollection as PropertyEditorPropertyDescriptionCollection_internal } from "./PropertyEditorPropertyDescriptionCollection";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
var IgrPropertyEditorDescriptionObject = /** @class */ /*@__PURE__*/ (function () {
    function IgrPropertyEditorDescriptionObject() {
        this.mounted = false;
        this._properties = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPropertyEditorDescriptionObject.prototype.createImplementation = function () {
        return new PropertyEditorDescriptionObject_internal();
    };
    Object.defineProperty(IgrPropertyEditorDescriptionObject.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorDescriptionObject.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorDescriptionObject.prototype.onImplementationCreated = function () {
    };
    IgrPropertyEditorDescriptionObject.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPropertyEditorDescriptionObject.prototype, "descriptionType", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorDescriptionObject.prototype, "properties", {
        get: function () {
            if (this._properties === null) {
                var coll = new IgrPropertyEditorPropertyDescriptionCollection();
                var innerColl = this.i.a;
                if (!innerColl) {
                    innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
                }
                this._properties = coll._fromInner(innerColl);
                this.i.a = innerColl;
            }
            return this._properties;
        },
        set: function (v) {
            if (this._properties !== null) {
                this._properties._setSyncTarget(null);
                this._properties = null;
            }
            var coll = new IgrPropertyEditorPropertyDescriptionCollection();
            this._properties = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PropertyEditorPropertyDescription.$type);
            var innerColl = this.i.a;
            if (!innerColl) {
                innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._properties._setSyncTarget(syncColl);
            this.i.a = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorDescriptionObject.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.properties != null && this.properties.findByName && this.properties.findByName(name)) {
            return this.properties.findByName(name);
        }
        return null;
    };
    return IgrPropertyEditorDescriptionObject;
}());
export { IgrPropertyEditorDescriptionObject };
