import { __extends, __values } from "tslib";
import * as React from 'react';
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { IgrPropertyEditorDescriptionObject } from "./igr-property-editor-description-object";
import { IgrPropertyEditorDescriptionObjectCollection } from "./igr-property-editor-description-object-collection";
import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { IgrPropertyEditorPropertyDescriptionButtonClickEventArgs } from "./igr-property-editor-property-description-button-click-event-args";
import { IgrPropertyEditorPropertyDescriptionChangedEventArgs } from "./igr-property-editor-property-description-changed-event-args";
import { IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./igr-property-editor-property-description-target-property-updating-event-args";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { TypeRegistrar } from "igniteui-react-core";
import { NamePatcher, getModifiedProps, isValidProp, ensureEnum, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-react-core";
import { PropertyEditorDescriptionObjectCollection as PropertyEditorDescriptionObjectCollection_internal } from "./PropertyEditorDescriptionObjectCollection";
import { PropertyEditorDescriptionObject } from "./PropertyEditorDescriptionObject";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionCollection as PropertyEditorPropertyDescriptionCollection_internal } from "./PropertyEditorPropertyDescriptionCollection";
var IgrPropertyEditorPropertyDescription = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPropertyEditorPropertyDescription, _super);
    function IgrPropertyEditorPropertyDescription(props) {
        var _this = _super.call(this, props) || this;
        _this.mounted = false;
        _this._complexValues = null;
        _this._properties = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._buttonClicked = null;
        _this._buttonClicked_wrapped = null;
        _this._changed = null;
        _this._changed_wrapped = null;
        _this._targetPropertyUpdating = null;
        _this._targetPropertyUpdating_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        if (_this._initializeAdapters) {
            _this._initializeAdapters();
        }
        return _this;
    }
    IgrPropertyEditorPropertyDescription.prototype.createImplementation = function () {
        return new PropertyEditorPropertyDescription();
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorPropertyDescription._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrPropertyEditorPropertyDescription.prototype.onImplementationCreated = function () {
    };
    IgrPropertyEditorPropertyDescription.prototype.componentDidMount = function () {
        var e_1, _a;
        this.mounted = true;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrPropertyEditorPropertyDescription.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrPropertyEditorPropertyDescription.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "propertyPath", {
        get: function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "label", {
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "valueType", {
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = ensureEnum(PropertyEditorValueType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "propertyDescriptionType", {
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "shouldOverrideDefaultEditor", {
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "elementDescriptionType", {
        get: function () {
            return this.i.ak;
        },
        set: function (v) {
            this.i.ak = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "dropDownNames", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "dropDownValues", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "primitiveValue", {
        get: function () {
            return this.i.af;
        },
        set: function (v) {
            this.i.af = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "min", {
        get: function () {
            return this.i.ab;
        },
        set: function (v) {
            this.i.ab = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "editorWidth", {
        get: function () {
            return this.i.y;
        },
        set: function (v) {
            this.i.y = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "labelWidth", {
        get: function () {
            return this.i.z;
        },
        set: function (v) {
            this.i.z = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "max", {
        get: function () {
            return this.i.aa;
        },
        set: function (v) {
            this.i.aa = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "step", {
        get: function () {
            return this.i.ac;
        },
        set: function (v) {
            this.i.ac = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "complexValue", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPropertyEditorDescriptionObject();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "complexValues", {
        get: function () {
            if (this._complexValues === null) {
                var coll = new IgrPropertyEditorDescriptionObjectCollection();
                var innerColl = this.i.i;
                if (!innerColl) {
                    innerColl = new PropertyEditorDescriptionObjectCollection_internal();
                }
                this._complexValues = coll._fromInner(innerColl);
                this.i.i = innerColl;
            }
            return this._complexValues;
        },
        set: function (v) {
            if (this._complexValues !== null) {
                this._complexValues._setSyncTarget(null);
                this._complexValues = null;
            }
            var coll = new IgrPropertyEditorDescriptionObjectCollection();
            this._complexValues = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
            var innerColl = this.i.i;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._complexValues._setSyncTarget(syncColl);
            this.i.i = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "properties", {
        get: function () {
            if (this._properties === null) {
                var coll = new IgrPropertyEditorPropertyDescriptionCollection();
                var innerColl = this.i.m;
                if (!innerColl) {
                    innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
                }
                this._properties = coll._fromInner(innerColl);
                this.i.m = innerColl;
            }
            return this._properties;
        },
        set: function (v) {
            if (this._properties !== null) {
                this._properties._setSyncTarget(null);
                this._properties = null;
            }
            var coll = new IgrPropertyEditorPropertyDescriptionCollection();
            this._properties = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PropertyEditorPropertyDescription.$type);
            var innerColl = this.i.m;
            if (!innerColl) {
                innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._properties._setSyncTarget(syncColl);
            this.i.m = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorPropertyDescription.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.complexValue && this.complexValue.name && this.complexValue.name == name) {
            return this.complexValue;
        }
        if (this.complexValues != null && this.complexValues.findByName && this.complexValues.findByName(name)) {
            return this.complexValues.findByName(name);
        }
        if (this.properties != null && this.properties.findByName && this.properties.findByName(name)) {
            return this.properties.findByName(name);
        }
        return null;
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrPropertyEditorPropertyDescription.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrPropertyEditorPropertyDescription.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("PropertyEditorPropertyDescription");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "buttonClicked", {
        get: function () {
            return this._buttonClicked;
        },
        set: function (ev) {
            var _this = this;
            if (this._buttonClicked_wrapped !== null) {
                this.i.buttonClicked = delegateRemove(this.i.buttonClicked, this._buttonClicked_wrapped);
                this._buttonClicked_wrapped = null;
                this._buttonClicked = null;
            }
            this._buttonClicked = ev;
            this._buttonClicked_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyEditorPropertyDescriptionButtonClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeButtonClicked) {
                    _this.beforeButtonClicked(_this, outerArgs);
                }
                if (_this._buttonClicked) {
                    _this._buttonClicked(_this, outerArgs);
                }
            };
            this.i.buttonClicked = delegateCombine(this.i.buttonClicked, this._buttonClicked_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "changed", {
        get: function () {
            return this._changed;
        },
        set: function (ev) {
            var _this = this;
            if (this._changed_wrapped !== null) {
                this.i.changed = delegateRemove(this.i.changed, this._changed_wrapped);
                this._changed_wrapped = null;
                this._changed = null;
            }
            this._changed = ev;
            this._changed_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyEditorPropertyDescriptionChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeChanged) {
                    _this.beforeChanged(_this, outerArgs);
                }
                if (_this._changed) {
                    _this._changed(_this, outerArgs);
                }
            };
            this.i.changed = delegateCombine(this.i.changed, this._changed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPropertyEditorPropertyDescription.prototype, "targetPropertyUpdating", {
        get: function () {
            return this._targetPropertyUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._targetPropertyUpdating_wrapped !== null) {
                this.i.targetPropertyUpdating = delegateRemove(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
                this._targetPropertyUpdating_wrapped = null;
                this._targetPropertyUpdating = null;
            }
            this._targetPropertyUpdating = ev;
            this._targetPropertyUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeTargetPropertyUpdating) {
                    _this.beforeTargetPropertyUpdating(_this, outerArgs);
                }
                if (_this._targetPropertyUpdating) {
                    _this._targetPropertyUpdating(_this, outerArgs);
                }
            };
            this.i.targetPropertyUpdating = delegateCombine(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPropertyEditorPropertyDescription;
}(React.Component));
export { IgrPropertyEditorPropertyDescription };
