import { __extends } from "tslib";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionRadio } from "./ToolActionRadio";
import { ensureBool, brushToString, stringToBrush } from "igniteui-react-core";
var IgrToolActionRadio = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionRadio, _super);
    function IgrToolActionRadio(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionRadio.prototype.createImplementation = function () {
        return new ToolActionRadio();
    };
    Object.defineProperty(IgrToolActionRadio.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "channel", {
        /**
         * Gets or sets the channel this radio button belongs to.
        */
        get: function () {
            return this.i.hk;
        },
        set: function (v) {
            this.i.hk = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "isChecked", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.hd;
        },
        set: function (v) {
            this.i.hd = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "isManual", {
        /**
         * Gets or sets if the checked state of the radio is handled manually by the user. The radio
         * well not become selected when clicked if this property is true.
        */
        get: function () {
            return this.i.he;
        },
        set: function (v) {
            this.i.he = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "uncheckedBackgroundColor", {
        /**
         * Gets or sets the background color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.h8);
        },
        set: function (v) {
            this.i.h8 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "actualUncheckedBackgroundColor", {
        /**
         * Gets the actual background color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.h4);
        },
        set: function (v) {
            this.i.h4 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "checkedBackgroundColor", {
        /**
         * Gets or sets the background color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.h6);
        },
        set: function (v) {
            this.i.h6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "actualCheckedBackgroundColor", {
        /**
         * Gets the actual background color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.h2);
        },
        set: function (v) {
            this.i.h2 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "uncheckedBorderColor", {
        /**
         * Gets or sets the border color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.h9);
        },
        set: function (v) {
            this.i.h9 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "actualUncheckedBorderColor", {
        /**
         * Gets the actual border color of the radio when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.h5);
        },
        set: function (v) {
            this.i.h5 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "checkedBorderColor", {
        /**
         * Gets or sets the border color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.h7);
        },
        set: function (v) {
            this.i.h7 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionRadio.prototype, "actualCheckedBorderColor", {
        /**
         * Gets the actual border color of the radio when in the checked state.
        */
        get: function () {
            return brushToString(this.i.h3);
        },
        set: function (v) {
            this.i.h3 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionRadio;
}(IgrToolAction));
export { IgrToolActionRadio };
