import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUIAbsolutePanel } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { IDataSource } from "igniteui-react-core";
import { IExternalListPanel } from "./IExternalListPanel";
import { IExecutionContext } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ListPanelOrientation } from "./ListPanelOrientation";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelItemPresenter } from "./ListPanelItemPresenter";
import { NativeUIContent } from "igniteui-react-core";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { Rect } from "igniteui-react-core";
import { ListPanelItemVisualData } from "./ListPanelItemVisualData";
import { IDataSourceUpdateNotifier } from "igniteui-react-core";
import { NativeUIContainer } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ListPanelView extends Base {
    static $t: Type;
    private n;
    private m;
    constructor();
    p(): any;
    a: ListPanel;
    v(): void;
    i: DomRenderer;
    l: DomWrapper;
    e: RenderingContext;
    k: DomWrapper;
    t(a: DomRenderer): void;
    y(): void;
    x(): void;
    s(): void;
    z(): void;
    private b;
    private aa;
    private c;
    private _gridExternal;
    d(): FontInfo;
    u(): void;
    w(): void;
    r(a: number, b: number): void;
    g(): number;
    h(a: string): number;
    f: boolean;
    private j;
    q(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class ListPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    o: ListPanelView;
    u: NativeUIGrid;
    private y;
    private v;
    private get w();
    private h;
    b0(a: NativeUIAbsolutePanel): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private ba;
    ci(a: Size): void;
    get itemsSource(): any;
    set itemsSource(a: any);
    private a;
    get actualDataSource(): IDataSource;
    set actualDataSource(a: IDataSource);
    private ag;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private a2;
    get a9(): number;
    set a9(a: number);
    private ar;
    get av(): number;
    set av(a: number);
    private r;
    get s(): FontInfo;
    set s(a: FontInfo);
    t(): FontInfo;
    private x;
    get ah(): boolean;
    private bb;
    protected cf(a: string, b: any, c: any): void;
    private br;
    private as;
    private aq;
    private ap;
    private ad;
    private z;
    private ac;
    protected cm(): void;
    private bt;
    contentRefreshed: (sender: any, args: ListPanelContentRefreshedEventArgs) => void;
    private cq;
    private bu;
    rowUpdating: (sender: any, args: ListPanelTemplateItemUpdatingEventArgs) => void;
    private bx;
    private bw;
    private q;
    itemWidthRequested: (sender: any, args: ListPanelTemplateWidthRequestedEventArgs) => void;
    itemHeightRequested: (sender: any, args: ListPanelTemplateHeightRequestedEventArgs) => void;
    private bq;
    private ay;
    private az;
    private bv;
    private g;
    private p;
    private ct;
    private ao;
    private cp;
    private a8;
    private a7;
    private al;
    private ak;
    private an;
    private am;
    ax(a: number): number;
    aw(a: number): number;
    private bp;
    by(): void;
    cr(): void;
    private b5;
    private ae;
    private ab;
    private b4;
    bz(): void;
    cs(): void;
    a6(): number;
    a5(): number;
    private a0;
    private a1;
    private aj;
    b3(): void;
    private b2;
    private cn;
    private co;
    cl(): void;
    private b1;
    private cd;
    private d;
    get externalListPanel(): IExternalListPanel;
    set externalListPanel(a: IExternalListPanel);
    protected cj(a: string, b: any, c: any): void;
    c: IExecutionContext;
    cu(): void;
    c1(): Size;
    cc(a: number, b: number): void;
    ch(a: number, b: any, c: any): void;
    cb(): void;
    ce(a: number, b: any): void;
    cg(a: number, b: any): void;
    b9(a: number, b: any, c: any): void;
    b6(): void;
    b7(a: number, b: any): void;
    b8(a: number, b: any): void;
    a3(a: any): number;
    a4(a: any[]): number;
    static cy: Brush;
    private cv;
    get cx(): Brush;
    set cx(a: Brush);
    static j: ListPanelOrientation;
    private i;
    get k(): ListPanelOrientation;
    set k(a: ListPanelOrientation);
    static af: boolean;
    private aa;
    get ai(): boolean;
    set ai(a: boolean);
    static cz: Brush;
    cw: Brush;
    get c0(): Brush;
    set c0(a: Brush);
    get au(): number;
    get at(): number;
    bc(): any;
    bj(): string;
}
/**
 * @hidden
 */
export declare class ListPanelTemplateItemUpdatingEventArgs extends Base {
    static $t: Type;
    a: ListPanelItemModel;
    c: any;
    b: NativeUIContent;
}
/**
 * @hidden
 */
export declare class ListPanelDataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: ListPanel);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
/**
 * @hidden
 */
export declare class ListPanelLayoutPanel extends Base {
    static $t: Type;
    private a;
    constructor(a: NativeUIAbsolutePanel);
    g(a: Size): void;
    h(): Rect;
    b(a: NativeUIComponent): number;
    c(a: NativeUIComponent): number;
    d(a: ListPanel, b: ListPanelItemModel): void;
    e(a: NativeUIContainer): void;
    f(a: ListPanelItemModel): void;
}
/**
 * @hidden
 */
export declare class ListPanelItemModel extends Base {
    static $t: Type;
    e: boolean;
    n: number;
    l: number;
    private o;
    get p(): any;
    set p(a: any);
    b: ListPanelItemPresenter;
    private c;
    get g(): boolean;
    set g(a: boolean);
    f: boolean;
    private d;
    get h(): boolean;
    set h(a: boolean);
    private i;
    get k(): number;
    set k(a: number);
    private j;
    get m(): number;
    set m(a: number);
    a(a: ListPanelLayoutPanel): ListPanelItemVisualData;
}
