import { Base, Type, INotifyPropertyChanged, EventArgs, PropertyChangedEventArgs } from "igniteui-react-core";
import { INativeUIElementFactory } from "igniteui-react-core";
import { NativeUIElementFactoryFlavor } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { NativeUIComponentBuiltInType } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { XComponentBridge } from "igniteui-react-inputs";
import { INativeUIToolPanelBridge } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-react-core";
import { NativeUIBuiltInEvents } from "igniteui-react-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { NativeUIBuiltInProperties } from "igniteui-react-core";
import { ToolPanelOrientation } from "./ToolPanelOrientation";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ToolPanelContext } from "./ToolPanelContext";
import { RenderingContext } from "igniteui-react-core";
import { ToolbarOrientation } from "./ToolbarOrientation";
import { ListPanel } from "./ListPanel";
import { List$1 } from "igniteui-react-core";
import { Popup } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { NativeUIContentRefreshedEventArgs } from "./NativeUIContentRefreshedEventArgs";
import { IExecutionContext } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { ToolActionType } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { ToolPanelContextChangedEventArgs } from "./ToolPanelContextChangedEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { ToolCommandArgument } from "igniteui-react-core";
import { NativeUIIcon } from "igniteui-react-core";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolActionPerformedEventArgs } from "./ToolActionPerformedEventArgs";
import { ToolCommand } from "igniteui-react-core";
import { NativeUIButton } from "igniteui-react-core";
import { NativeUIButtonClickedEventArgs } from "igniteui-react-core";
import { NativeUIClickedEventArgs } from "igniteui-react-core";
import { LayoutSelectedKeysCollection } from "./LayoutSelectedKeysCollection";
import { ToolActionButtonDisplayType } from "./ToolActionButtonDisplayType";
import { NativeUIPopup } from "igniteui-react-core";
import { NativeUIMouseEventArgs } from "igniteui-react-core";
import { NativeUIFocusEventArgs } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { ToolCommandStateType } from "igniteui-react-core";
import { NestedActionMode } from "./NestedActionMode";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { NativeUIAbsolutePanel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class NativeUILayoutFactory extends Base implements INativeUIElementFactory {
    static $t: Type;
    private static a;
    static get b(): NativeUILayoutFactory;
    static e(): void;
    private c;
    get flavor(): NativeUIElementFactoryFlavor;
    createComponent(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    createComponentSync(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    supportsComponent(a: NativeUIComponentBuiltInType): boolean;
    private d;
}
/**
 * @hidden
 */
export declare class XToolPanelBridge extends XComponentBridge implements INativeUIToolPanelBridge {
    static $t: Type;
    private u;
    private x;
    private v;
    private y;
    private w;
    private z;
    constructor(a: any);
    getDesiredSize(a: any, b: Size): Size;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    private ab;
    private ac;
    private aa;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    refresh(a: any): void;
    notifySizeChanged(a: any, b: Size): void;
    getContext(a: any): ToolPanelContext;
    setContext(a: any, b: ToolPanelContext): void;
}
/**
 * @hidden
 */
export declare class ToolbarView extends Base {
    static $t: Type;
    private o;
    private n;
    private g;
    constructor();
    q(): any;
    a: Toolbar;
    w(): void;
    j: DomRenderer;
    m: DomWrapper;
    e: RenderingContext;
    l: DomWrapper;
    u(a: DomRenderer): void;
    z(): void;
    y(): void;
    t(): void;
    aa(): void;
    private b;
    private ab;
    private c;
    private _gridExternal;
    d(): FontInfo;
    v(): void;
    x(): void;
    s(): void;
    h(): number;
    i(a: string): number;
    f: boolean;
    private k;
    r(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class ToolPanelView extends Base {
    static $t: Type;
    private u;
    private t;
    constructor();
    x(): any;
    c: ToolPanel;
    ae(): void;
    p: DomRenderer;
    get v(): DomWrapper;
    s: DomWrapper;
    i: RenderingContext;
    r: DomWrapper;
    ac(a: DomRenderer): void;
    ah(): void;
    aa(): void;
    m(): number;
    l(): number;
    ai(): void;
    private d;
    private e;
    private ak;
    private f;
    private _gridExternal;
    g(): FontInfo;
    h(): FontInfo;
    ad(): void;
    ag(): void;
    af(): void;
    ab(): void;
    z(): void;
    k(): number;
    n(a: string): number;
    o(a: string, b: FontInfo): number;
    j: boolean;
    private q;
    y(a: any, b: (arg1: any) => void): void;
    a(): Popup;
    b(a: NativeUIContent): ToolPanel;
    aj(a: any): Rect;
}
/**
 * @hidden
 */
export declare class NativeUIToolPanel extends NativeUIComponent {
    static $t: Type;
    private get bm();
    get br(): ToolActionCollection;
    set br(a: ToolActionCollection);
    get bx(): number;
    set bx(a: number);
    get bw(): number;
    get bt(): ToolPanelOrientation;
    set bt(a: ToolPanelOrientation);
    get cd(): Brush;
    set cd(a: Brush);
    get cc(): Brush;
    set cc(a: Brush);
    get b5(): Brush;
    set b5(a: Brush);
    get bv(): FontInfo;
    set bv(a: FontInfo);
    get b3(): Brush;
    set b3(a: Brush);
    get b0(): Brush;
    set b0(a: Brush);
    get cb(): Brush;
    set cb(a: Brush);
    get b4(): Brush;
    set b4(a: Brush);
    get b6(): Brush;
    set b6(a: Brush);
    get ca(): Brush;
    set ca(a: Brush);
    get bu(): FontInfo;
    set bu(a: FontInfo);
    get b9(): Brush;
    set b9(a: Brush);
    get ce(): Brush;
    set ce(a: Brush);
    get b1(): Brush;
    set b1(a: Brush);
    get cf(): Brush;
    set cf(a: Brush);
    get b2(): Brush;
    set b2(a: Brush);
    get b7(): Brush;
    set b7(a: Brush);
    get bs(): ToolPanelContext;
    set bs(a: ToolPanelContext);
    get b8(): Brush;
    set b8(a: Brush);
    private bn;
    get bo(): (sender: any, args: NativeUIContentRefreshedEventArgs) => void;
    set bo(a: (sender: any, args: NativeUIContentRefreshedEventArgs) => void);
    private bi;
    get bk(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bk(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bj;
    get bl(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bl(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bp;
    get bq(): (sender: any, args: ToolCommandEventArgs) => void;
    set bq(a: (sender: any, args: ToolCommandEventArgs) => void);
    bz(): void;
    by(a: Size): void;
}
/**
 * @hidden
 */
export declare abstract class ToolAction extends Base implements INotifyPropertyChanged {
    static $t: Type;
    p: ToolPanel;
    f4(a: ToolPanel): void;
    private q;
    protected fs(): void;
    private e;
    get f(): IExecutionContext;
    set f(a: IExecutionContext);
    private cs;
    get ee(): string;
    i: ToolAction;
    private k;
    get actions(): ToolActionCollection;
    private bt;
    get ck(): number;
    set ck(a: number);
    constructor();
    e3(): void;
    private fi;
    private fj;
    private fl;
    protected e2(a: ToolAction, b: string): void;
    private es;
    m(a: boolean): ToolActionEventDetail;
    private fg;
    protected fh(a: List$1<ToolCommandArgument>): void;
    eq(): string;
    co(): any;
    cp(): any;
    private cw;
    get eo(): string;
    set eo(a: string);
    dk: string;
    dh: string;
    ej: string;
    er(): string;
    private cr;
    get dq(): string;
    set dq(a: string);
    private cq;
    get dm(): string;
    set dm(a: string);
    private cl;
    get cm(): any;
    set cm(a: any);
    private r;
    get s(): BaseControlTheme;
    set s(a: BaseControlTheme);
    private bp;
    get cg(): number;
    set cg(a: number);
    private bc;
    get bz(): number;
    set bz(a: number);
    private bq;
    get ch(): number;
    set ch(a: number);
    private bd;
    get b0(): number;
    set b0(a: number);
    private bo;
    get cf(): number;
    set cf(a: number);
    private bb;
    get by(): number;
    set by(a: number);
    private br;
    get ci(): number;
    set ci(a: number);
    private be;
    get b1(): number;
    set b1(a: number);
    private ge;
    get gv(): Brush;
    set gv(a: Brush);
    private gn;
    get g3(): Brush;
    set g3(a: Brush);
    private gk;
    private gb;
    get gs(): Brush;
    set gs(a: Brush);
    private gj;
    get g0(): Brush;
    set g0(a: Brush);
    private gi;
    get gz(): Brush;
    set gz(a: Brush);
    private gr;
    get g7(): Brush;
    set g7(a: Brush);
    private gh;
    get gy(): Brush;
    set gy(a: Brush);
    private gq;
    get g6(): Brush;
    set g6(a: Brush);
    private gc;
    get gt(): Brush;
    set gt(a: Brush);
    private gl;
    get g1(): Brush;
    set g1(a: Brush);
    private w;
    get ab(): FontInfo;
    set ab(a: FontInfo);
    private z;
    get ae(): FontInfo;
    set ae(a: FontInfo);
    private v;
    get aa(): FontInfo;
    set aa(a: FontInfo);
    private y;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    private ap;
    get az(): boolean;
    set az(a: boolean);
    private aq;
    get a0(): boolean;
    set a0(a: boolean);
    get ay(): boolean;
    private cv;
    get eh(): string;
    set eh(a: string);
    private cy;
    get ez(): string;
    set ez(a: string);
    private cx;
    get et(): string;
    set et(a: string);
    private bs;
    protected get_cj(): number;
    get cj(): number;
    private cu;
    get d4(): string;
    set d4(a: string);
    private ct;
    get dz(): string;
    set dz(a: string);
    private bk;
    get cb(): number;
    set cb(a: number);
    private bl;
    get cc(): number;
    set cc(a: number);
    private bm;
    get cd(): number;
    set cd(a: number);
    private bj;
    get ca(): number;
    set ca(a: number);
    private go;
    get g4(): Brush;
    set g4(a: Brush);
    private gf;
    get gw(): Brush;
    set gw(a: Brush);
    private a;
    get c(): BrushCollection;
    set c(a: BrushCollection);
    private gp;
    get g5(): Brush;
    set g5(a: Brush);
    private gg;
    get gx(): Brush;
    set gx(a: Brush);
    private b;
    get d(): BrushCollection;
    set d(a: BrushCollection);
    private bi;
    get b9(): number;
    set b9(a: number);
    private bn;
    get ce(): number;
    set ce(a: number);
    private ba;
    get bx(): number;
    set bx(a: number);
    private bh;
    get b8(): number;
    set b8(a: number);
    private a9;
    get bw(): number;
    set bw(a: number);
    private g8;
    get g9(): Visibility;
    set g9(a: Visibility);
    private ao;
    get as(): boolean;
    set as(a: boolean);
    private bg;
    get b7(): number;
    set b7(a: number);
    private a8;
    get bv(): number;
    set bv(a: number);
    private bf;
    get b6(): number;
    set b6(a: number);
    private a7;
    get bu(): number;
    set bu(a: number);
    private gm;
    get g2(): Brush;
    set g2(a: Brush);
    private gd;
    get gu(): Brush;
    set gu(a: Brush);
    protected get_av(): boolean;
    protected get av(): boolean;
    protected get_aw(): boolean;
    protected get aw(): boolean;
    protected get_a2(): boolean;
    protected get a2(): boolean;
    protected get_a4(): boolean;
    protected get a4(): boolean;
    protected get_ar(): boolean;
    protected get ar(): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected fm(): void;
    protected ft(a: string, b: any, c: any): void;
    protected get_u(): ToolActionType;
    get u(): ToolActionType;
    protected f0(a: string, b: any, c: any): void;
    private f7;
    private fq;
    protected fc(a: string, b: any, c: any): void;
    private f6;
    private x;
    protected a1(): boolean;
    f9(): void;
    protected ga(): void;
    protected fr(): void;
    fv(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    fw(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    e8(a: ToolPanel, b: ToolActionMeasurementContext): void;
    e9(a: ToolPanel, b: ToolActionMeasurementContext): void;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    b5(a: ToolPanel, b: ToolActionMeasurementContext): number;
    b3(a: ToolPanel, b: ToolActionMeasurementContext): number;
    ac(a: ToolPanel): FontInfo;
    b2(a: ToolPanel, b: ToolActionMeasurementContext): number;
    fu(a: ToolActionEventDetail, b: ToolAction): void;
    private f2;
    protected f3(a: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    protected a5(): boolean;
    private e6;
    ax(): boolean;
    private fn;
    private e7;
    performed: (sender: any, args: ToolActionPerformedEventArgs) => void;
    static h(a: ToolActionInfo): ToolAction;
    protected t: ToolActionInfo;
    protected ff(): void;
    protected a3(): boolean;
    protected a6(): boolean;
    protected ag(a: NativeUIComponentBuiltInType): NativeUIElementFactoryFlavor;
    private aj;
    protected get ak(): NativeUIGrid;
    private ah;
    private af;
    private al;
    private ai;
    private am;
    private an;
    private fe;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected fb(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected f8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private fa;
    private au;
    private fk;
    private f5;
    protected e4(a: NativeUIContent): void;
    protected fp(): void;
    protected fo(a: any, b: NativeUIClickedEventArgs): void;
    fy(): void;
    e5(): void;
    fz(a: ToolAction): void;
    protected f1(a: string, b: any): void;
    protected j<T>($t: Type, a: string): T;
    static at(a: ToolAction, b: ToolActionInfo): boolean;
    g(): NativeUIToolPanel;
    cn(): any;
    du(): string;
}
/**
 * @hidden
 */
export declare class ToolActionCheckboxList extends ToolAction {
    static $t: Type;
    private hd;
    private hg;
    private he;
    private hi;
    private hf;
    protected get_u(): ToolActionType;
    e9(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    private hh;
    get itemsSource(): any;
    set itemsSource(a: any);
    private hl;
    get hr(): string;
    set hr(a: string);
    private hk;
    get hm(): string;
    set hm(a: string);
    private ha;
    get hb(): string[];
    set hb(a: string[]);
    get hc(): LayoutSelectedKeysCollection;
    set hc(a: LayoutSelectedKeysCollection);
    protected f0(a: string, b: any, c: any): void;
    private hw;
    private ht;
    private hu;
    private hv;
    m(a: boolean): ToolActionEventDetail;
    protected fh(a: List$1<ToolCommandArgument>): void;
    protected f8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ff(): void;
}
/**
 * @hidden
 */
export declare class ToolActionSubPanel extends ToolAction {
    static $t: Type;
    private ha;
    private hb;
    constructor();
    protected get_u(): ToolActionType;
    e9(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private hd;
    private hc;
    protected e4(a: NativeUIContent): void;
    protected f0(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class ToolActionButton extends ToolAction {
    static $t: Type;
    protected get_u(): ToolActionType;
    protected get_cj(): number;
    private ha;
    get hb(): ToolActionButtonDisplayType;
    set hb(a: ToolActionButtonDisplayType);
    private hf;
    get hg(): number;
    set hg(a: number);
    private hd;
    m(a: boolean): ToolActionEventDetail;
    private hc;
    b3(a: ToolPanel, b: ToolActionMeasurementContext): number;
    b5(a: ToolPanel, b: ToolActionMeasurementContext): number;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    private hk;
    private hj;
    private he;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected f0(a: string, b: any, c: any): void;
    protected ga(): void;
}
/**
 * @hidden
 */
export declare class ToolActionLabel extends ToolAction {
    static $t: Type;
    private static readonly hb;
    private ha;
    protected get_av(): boolean;
    constructor();
    protected get_u(): ToolActionType;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private hc;
    protected fp(): void;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected f0(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class ToolActionRadio extends ToolAction {
    static $t: Type;
    private ha;
    protected get_u(): ToolActionType;
    private hf;
    get hk(): string;
    set hk(a: string);
    private hb;
    get hd(): boolean;
    set hd(a: boolean);
    private hc;
    get he(): boolean;
    set he(a: boolean);
    private h0;
    get h8(): Brush;
    set h8(a: Brush);
    private hw;
    get h4(): Brush;
    set h4(a: Brush);
    private hy;
    get h6(): Brush;
    set h6(a: Brush);
    private hu;
    get h2(): Brush;
    set h2(a: Brush);
    private h1;
    get h9(): Brush;
    set h9(a: Brush);
    private hx;
    get h5(): Brush;
    set h5(a: Brush);
    private hz;
    get h7(): Brush;
    set h7(a: Brush);
    private hv;
    get h3(): Brush;
    set h3(a: Brush);
    m(a: boolean): ToolActionEventDetail;
    protected fh(a: List$1<ToolCommandArgument>): void;
    hr(): void;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected ga(): void;
    protected fp(): void;
    private hs;
    private ht;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected f0(a: string, b: any, c: any): void;
    protected ff(): void;
}
/**
 * @hidden
 */
export declare class ToolActionSeparator extends ToolAction {
    static $t: Type;
    private hc;
    get hd(): number;
    set hd(a: number);
    private ha;
    get hb(): boolean;
    set hb(a: boolean);
    constructor();
    protected get_u(): ToolActionType;
    e9(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected fb(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected f8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ga(): void;
    protected f0(a: string, b: any, c: any): void;
    protected ff(): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconButton extends ToolAction {
    static $t: Type;
    private he;
    private hb;
    private ha;
    private h7;
    private h8;
    private hl;
    private hi;
    private hh;
    private hm;
    protected get_u(): ToolActionType;
    protected get_a4(): boolean;
    protected get hf(): NativeUIPopup;
    protected get_hp(): boolean;
    protected get hp(): boolean;
    private hk;
    private h9;
    get ib(): number;
    set ib(a: number);
    private h6;
    get ia(): number;
    set ia(a: number);
    private hn;
    private hv;
    get h3(): number;
    set h3(a: number);
    private hr;
    get hz(): number;
    set hz(a: number);
    private hx;
    get h5(): number;
    set h5(a: number);
    private ht;
    get h1(): number;
    set h1(a: number);
    private hw;
    get h4(): number;
    set h4(a: number);
    private hs;
    get h0(): number;
    set h0(a: number);
    private hu;
    get h2(): number;
    set h2(a: number);
    private hq;
    get hy(): number;
    set hy(a: number);
    constructor();
    e3(): void;
    m(a: boolean): ToolActionEventDetail;
    protected hc: NativeUIButton;
    protected hd: NativeUIIcon;
    b3(a: ToolPanel, b: ToolActionMeasurementContext): number;
    b5(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected fd(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected e4(a: NativeUIContent): void;
    private i8;
    protected i9(a: NativeUIGrid, b: NativeUIPopup): void;
    protected ip(): void;
    protected iq(a: boolean, b: boolean): void;
    protected is(): void;
    protected ir(): void;
    protected it(): void;
    protected ja(): Size;
    private i6;
    private i5;
    private ho;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ga(): void;
    protected fr(): void;
    fy(): void;
    e5(): void;
    protected i7(a?: boolean): void;
    private hg;
    protected io(): void;
    private iz;
    private iu;
    protected ix(a: any, b: NativeUIMouseEventArgs): void;
    protected iy(a: any, b: NativeUIMouseEventArgs): void;
    protected iv(a: any, b: NativeUIButtonClickedEventArgs): void;
    private hj;
    private i3;
    private i4;
    private i1;
    private i2;
    private i0;
    protected iw(a: any, b: NativeUIFocusEventArgs): void;
    protected f0(a: string, b: any, c: any): void;
    protected ff(): void;
    cn(): any;
}
/**
 * @hidden
 */
export declare class ToolActionGroupHeader extends ToolAction {
    static $t: Type;
    private static readonly hd;
    private ha;
    private hb;
    protected get_u(): ToolActionType;
    protected get_av(): boolean;
    protected get_aw(): boolean;
    protected get_a2(): boolean;
    private hh;
    get hj(): Brush;
    set hj(a: Brush);
    private hi;
    get hk(): Brush;
    set hk(a: Brush);
    constructor();
    ac(a: ToolPanel): FontInfo;
    b2(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private hg;
    private hf;
    protected e4(a: NativeUIContent): void;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ga(): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconMenu extends ToolActionIconButton {
    static $t: Type;
    protected static readonly jl: string;
    private jj;
    private ji;
    private jh;
    private jb;
    private jd;
    protected jc: NativeUIIcon;
    protected get_u(): ToolActionType;
    constructor();
    private js;
    get ju(): Brush;
    set ju(a: Brush);
    private jr;
    get jt(): Brush;
    set jt(a: Brush);
    private je;
    get jg(): boolean;
    set jg(a: boolean);
    protected get_hp(): boolean;
    protected iq(a: boolean, b: boolean): void;
    protected fm(): void;
    protected is(): void;
    protected ir(): void;
    protected it(): void;
    protected ga(): void;
    protected ja(): Size;
    protected i7(a?: boolean): void;
    b3(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private jq;
    private jf;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private jo;
    protected f0(a: string, b: any, c: any): void;
    private jp;
    protected e2(a: ToolAction, b: string): void;
    fz(a: ToolAction): void;
    g(): NativeUIToolPanel;
    cn(): any;
}
/**
 * @hidden
 */
export declare class ToolActionCheckbox extends ToolAction {
    static $t: Type;
    private ha;
    protected get_u(): ToolActionType;
    protected get_ar(): boolean;
    get hb(): boolean;
    set hb(a: boolean);
    private ht;
    get h1(): Brush;
    set h1(a: Brush);
    private hp;
    get hx(): Brush;
    set hx(a: Brush);
    private hr;
    get hz(): Brush;
    set hz(a: Brush);
    private hn;
    get hv(): Brush;
    set hv(a: Brush);
    private hu;
    get h2(): Brush;
    set h2(a: Brush);
    private hq;
    get hy(): Brush;
    set hy(a: Brush);
    private hs;
    get h0(): Brush;
    set h0(a: Brush);
    private ho;
    get hw(): Brush;
    set hw(a: Brush);
    m(a: boolean): ToolActionEventDetail;
    protected fh(a: List$1<ToolCommandArgument>): void;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected e4(a: NativeUIContent): void;
    protected fp(): void;
    private hm;
    private hl;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ga(): void;
    protected f0(a: string, b: any, c: any): void;
    protected fc(a: string, b: any, c: any): void;
    protected fs(): void;
}
/**
 * @hidden
 */
export declare class ToolActionNumberInput extends ToolAction {
    static $t: Type;
    private ha;
    protected get_u(): ToolActionType;
    private hb;
    get hd(): number;
    set hd(a: number);
    protected fh(a: List$1<ToolCommandArgument>): void;
    b4(a: ToolPanel, b: ToolActionMeasurementContext): number;
    hc(): number;
    m(a: boolean): ToolActionEventDetail;
    private hf;
    private hg;
    fx(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ga(): void;
    protected f0(a: string, b: any, c: any): void;
    protected fp(): void;
    protected ff(): void;
}
/**
 * @hidden
 */
export declare class ToolActionCollection extends ObservableCollection$1<ToolAction> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class Toolbar extends Base implements INotifyPropertyChanged, ICommandStateChangedListener {
    static $t: Type;
    m: ToolbarView;
    private aa;
    constructor();
    private y;
    private get z();
    private p;
    c0(a: ToolPanel): void;
    private cr;
    private n;
    private c7;
    private c5;
    c3(a: Size): void;
    private q;
    get r(): BaseControlTheme;
    set r(a: BaseControlTheme);
    private f;
    get autoGeneratedActions(): ToolActionCollection;
    set autoGeneratedActions(a: ToolActionCollection);
    private d;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private e;
    get actualActions(): ToolActionCollection;
    set actualActions(a: ToolActionCollection);
    static k: ToolbarOrientation;
    private j;
    get l(): ToolbarOrientation;
    set l(a: ToolbarOrientation);
    s: IToolbarTarget;
    static bc: any;
    private bb;
    get target(): any;
    set target(a: any);
    private dj;
    get d4(): Brush;
    set d4(a: Brush);
    private dx;
    get eh(): Brush;
    set eh(a: Brush);
    private dn;
    get d8(): Brush;
    set d8(a: Brush);
    private dw;
    get eg(): Brush;
    set eg(a: Brush);
    private ds;
    get ec(): Brush;
    set ec(a: Brush);
    dz: Brush;
    get ej(): Brush;
    set ej(a: Brush);
    dm: Brush;
    get d7(): Brush;
    set d7(a: Brush);
    private dq;
    get ea(): Brush;
    set ea(a: Brush);
    private d1;
    get el(): Brush;
    set el(a: Brush);
    private d0;
    get ek(): Brush;
    set ek(a: Brush);
    private at;
    get a5(): number;
    set a5(a: number);
    private au;
    get a6(): number;
    set a6(a: number);
    private dt;
    get ed(): Brush;
    set ed(a: Brush);
    private du;
    get ee(): Brush;
    set ee(a: Brush);
    private t;
    get v(): FontInfo;
    set v(a: FontInfo);
    private u;
    get x(): FontInfo;
    set x(a: FontInfo);
    w(): FontInfo;
    private aq;
    get a2(): number;
    set a2(a: number);
    private ar;
    get a3(): number;
    set a3(a: number);
    private as;
    get a4(): number;
    set a4(a: number);
    private ap;
    get a1(): number;
    set a1(a: number);
    private am;
    get ay(): number;
    set ay(a: number);
    private an;
    get az(): number;
    set az(a: number);
    private ao;
    get a0(): number;
    set a0(a: number);
    private al;
    get ax(): number;
    set ax(a: number);
    private ad;
    get ag(): boolean;
    set ag(a: boolean);
    private ak;
    get aw(): number;
    set aw(a: number);
    private aj;
    get av(): number;
    set av(a: number);
    private dr;
    get eb(): Brush;
    set eb(a: Brush);
    private dv;
    get ef(): Brush;
    set ef(a: Brush);
    private d2;
    get em(): Brush;
    set em(a: Brush);
    private dk;
    get d5(): Brush;
    set d5(a: Brush);
    private d3;
    get en(): Brush;
    set en(a: Brush);
    private dl;
    get d6(): Brush;
    set d6(a: Brush);
    private a8;
    get ba(): number;
    set ba(a: number);
    private dy;
    get ei(): Brush;
    set ei(a: Brush);
    private dp;
    get d9(): Brush;
    set d9(a: Brush);
    private a7;
    get a9(): number;
    set a9(a: number);
    private _userSetWidth;
    get userSetWidth(): boolean;
    set userSetWidth(a: boolean);
    private _userSetHeight;
    get userSetHeight(): boolean;
    set userSetHeight(a: boolean);
    private cs;
    private cu;
    private cv;
    private di;
    private ct;
    private c2;
    private ac;
    private ab;
    protected da(): void;
    private cy;
    private db;
    private ae;
    private af;
    private cz;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected c4(a: string, b: any, c: any): void;
    protected c8(a: string, b: any, c: any): void;
    private dg;
    eo(): Size;
    private c6;
    private dh;
    private b;
    get c(): IExecutionContext;
    set c(a: IExecutionContext);
    cw(): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    onCommandStateChanged(a: string, b: ToolCommandStateType, c: any): void;
    private dc;
    dd(a: string, b: string, c: string): void;
    bt(a: string, b: string): string;
    de(a: string, b: string, c: string[]): void;
    a(a: string, b: string): string[];
    df(a: string, b: any): void;
    be(a: string): any;
    bd(): any;
    bs(): string;
}
/**
 * @hidden
 */
export declare class ToolPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    s: ToolPanelView;
    ae: NativeUIGrid;
    ca: any;
    private m;
    get n(): ToolPanelContext;
    set n(a: ToolPanelContext);
    private ah;
    private af;
    private get ag();
    ew(a: ListPanel): void;
    private ej;
    private ek;
    private el;
    private i;
    private em;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private g;
    e1(a: Size): void;
    contentRefreshed: (sender: any, args: ToolPanelContentRefreshedEventArgs) => void;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private aj;
    get al(): boolean;
    set al(a: boolean);
    constructor();
    private en;
    private eo;
    private e0;
    private ai;
    protected e9(): void;
    fb(): void;
    private et;
    private an;
    private ao;
    private am;
    private ep;
    ak(a: ToolAction): boolean;
    f(a: string): ToolAction;
    ap(a: ToolAction): List$1<ToolAction>;
    private j;
    private e5;
    private ey;
    private ff;
    hv(): Size;
    private eu;
    ev(): void;
    fc(): void;
    fa(a: ToolAction): void;
    private ex;
    private eq;
    e6(): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private x;
    get ab(): FontInfo;
    set ab(a: FontInfo);
    private v;
    get z(): FontInfo;
    set z(a: FontInfo);
    private w;
    get aa(): FontInfo;
    set aa(a: FontInfo);
    private y;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    ac(): FontInfo;
    protected e3(a: string, b: any, c: any): void;
    protected e7(a: string, b: any, c: any): void;
    private fi;
    private fh;
    private fg;
    a: IExecutionContext;
    private t;
    get u(): BaseControlTheme;
    set u(a: BaseControlTheme);
    private f4;
    get ha(): Brush;
    set ha(a: Brush);
    private fj;
    get gp(): Brush;
    set gp(a: Brush);
    private gi;
    get ho(): Brush;
    set ho(a: Brush);
    private fx;
    get g3(): Brush;
    set g3(a: Brush);
    private f8;
    get he(): Brush;
    set he(a: Brush);
    private fn;
    get gt(): Brush;
    set gt(a: Brush);
    private gh;
    get hn(): Brush;
    set hn(a: Brush);
    private fw;
    get g2(): Brush;
    set g2(a: Brush);
    private f9;
    get hf(): Brush;
    set hf(a: Brush);
    static readonly cj: string;
    private fo;
    get gu(): Brush;
    set gu(a: Brush);
    private gd;
    get hj(): Brush;
    set hj(a: Brush);
    private fs;
    get gy(): Brush;
    set gy(a: Brush);
    private d;
    private a4;
    gk: Brush;
    get hq(): Brush;
    set hq(a: Brush);
    private fz;
    get g5(): Brush;
    set g5(a: Brush);
    private fy;
    get g4(): Brush;
    set g4(a: Brush);
    private gj;
    get hp(): Brush;
    set hp(a: Brush);
    f7: Brush;
    get hd(): Brush;
    set hd(a: Brush);
    private fm;
    get gs(): Brush;
    set gs(a: Brush);
    private gb;
    get hh(): Brush;
    set hh(a: Brush);
    private fq;
    get gw(): Brush;
    set gw(a: Brush);
    private ga;
    get hg(): Brush;
    set hg(a: Brush);
    private fp;
    get gv(): Brush;
    set gv(a: Brush);
    private gm;
    get hs(): Brush;
    set hs(a: Brush);
    private f1;
    get g7(): Brush;
    set g7(a: Brush);
    private gl;
    get hr(): Brush;
    set hr(a: Brush);
    private f0;
    get g6(): Brush;
    set g6(a: Brush);
    private bd;
    get b2(): number;
    set b2(a: number);
    private a0;
    get bq(): number;
    set bq(a: number);
    private be;
    get b3(): number;
    set b3(a: number);
    private a1;
    get br(): number;
    set br(a: number);
    private ge;
    get hk(): Brush;
    set hk(a: Brush);
    private ft;
    get gz(): Brush;
    set gz(a: Brush);
    private gf;
    get hl(): Brush;
    set hl(a: Brush);
    private fu;
    get g0(): Brush;
    set g0(a: Brush);
    private ba;
    get bz(): number;
    set bz(a: number);
    private ax;
    get bn(): number;
    set bn(a: number);
    private bb;
    get b0(): number;
    set b0(a: number);
    private ay;
    get bo(): number;
    set bo(a: number);
    private bc;
    get b1(): number;
    set b1(a: number);
    private az;
    get bp(): number;
    set bp(a: number);
    private a9;
    get by(): number;
    set by(a: number);
    private aw;
    get bm(): number;
    set bm(a: number);
    private a6;
    get bv(): number;
    set bv(a: number);
    private at;
    get bj(): number;
    set bj(a: number);
    private a7;
    get bw(): number;
    set bw(a: number);
    private au;
    get bk(): number;
    set bk(a: number);
    private a8;
    get bx(): number;
    set bx(a: number);
    private av;
    get bl(): number;
    set bl(a: number);
    private a5;
    get bu(): number;
    set bu(a: number);
    private as;
    get bi(): number;
    set bi(a: number);
    static q: ToolPanelOrientation;
    private p;
    get r(): ToolPanelOrientation;
    set r(a: ToolPanelOrientation);
    e4(a: ToolAction, b: ToolCommandEventArgs): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    get b8(): number;
    set b8(a: number);
    get bh(): number;
    private a3;
    get bt(): number;
    set bt(a: number);
    private ar;
    get bg(): number;
    set bg(a: number);
    private a2;
    get bs(): number;
    set bs(a: number);
    private aq;
    get bf(): number;
    set bf(a: number);
    private gc;
    get hi(): Brush;
    set hi(a: Brush);
    private fr;
    get gx(): Brush;
    set gx(a: Brush);
    private gg;
    get hm(): Brush;
    set hm(a: Brush);
    private fv;
    get g1(): Brush;
    set g1(a: Brush);
    private gn;
    get ht(): Brush;
    set ht(a: Brush);
    private f2;
    get g8(): Brush;
    set g8(a: Brush);
    private f5;
    get hb(): Brush;
    set hb(a: Brush);
    private fk;
    get gq(): Brush;
    set gq(a: Brush);
    private go;
    get hu(): Brush;
    set hu(a: Brush);
    private f3;
    get g9(): Brush;
    set g9(a: Brush);
    private f6;
    get hc(): Brush;
    set hc(a: Brush);
    private fl;
    get gr(): Brush;
    set gr(a: Brush);
    private b5;
    get b7(): number;
    set b7(a: number);
    private b4;
    get b6(): number;
    set b6(a: number);
    e: NestedActionMode;
    private e2;
    onContextChanged: (sender: any, args: ToolPanelContextChangedEventArgs) => void;
    drillDownRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    drillUpRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    fd(a: ToolAction): void;
    fe(a: ToolAction): void;
    er(): void;
    b9(): any;
    dl(): string;
}
/**
 * @hidden
 */
export declare class DrillDownRequestedEventArgs extends Base {
    static $t: Type;
    a: ToolAction;
}
/**
 * @hidden
 */
export declare class ToolPanelsPresenter extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private ad;
    private i;
    private j;
    private aa;
    private p;
    private a;
    private d;
    private g;
    private a0;
    private a1;
    private q;
    private b;
    private e;
    private h;
    private c;
    private f;
    private y;
    private u;
    private get a2();
    private set a2(value);
    private get a3();
    private set a3(value);
    s: NativeUIGrid;
    r: NativeUIAbsolutePanel;
    private w;
    get x(): List$1<PanelInfo>;
    private n;
    get o(): BaseControlTheme;
    set o(a: BaseControlTheme);
    private z;
    get ab(): number;
    set ab(a: number);
    t: (arg1: ToolCommandEventArgs) => void;
    private ac;
    constructor(a: any, b: IExecutionContext);
    ak(a: () => void): void;
    a4(): Size;
    k(): PanelInfo;
    ag(a: ToolAction, b?: (arg1: NativeUIToolPanel) => void): void;
    al(a: NativeUIToolPanel): void;
    an(a: number): void;
    am(a: PanelInfo, b?: () => void): void;
    private as;
    private at;
    private aq;
    private ah;
    private aj;
    private ap;
    private v;
    ax(): void;
    private ai;
    ay(): void;
    az(a: BaseControlTheme, b: ToolPanel): void;
    ao(): void;
    containerReady: (sender: any) => void;
    private ar;
    sizeChanged: (sender: any) => void;
    private av;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private au;
    protected aw(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class PanelInfo extends Base {
    static $t: Type;
    c: number;
    a: NativeUIToolPanel;
    b: ToolAction;
    constructor(a: ToolAction, b: NativeUIToolPanel, c: number);
    f(): Size;
    e(): void;
    d(a: Size): void;
}
/**
 * @hidden
 */
export declare class PanelAnimationRequest extends Base {
    static $t: Type;
    a: PanelInfo;
    c: number;
    b: () => void;
}
