import { LayoutPrimaryKeyValue as LayoutPrimaryKeyValue_internal } from "./LayoutPrimaryKeyValue";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * A primary key value.
*/
export declare class IgrLayoutPrimaryKeyValue {
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): LayoutPrimaryKeyValue_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The primary key associated with this value.
    */
    get key(): string[];
    set key(v: string[]);
    /**
     * The value of the keys for this primary key value.
    */
    get value(): any[];
    set value(v: any[]);
    findByName(name: string): any;
    /**
     * Determines if two primary key values are equal.
    
    * @param other  * The other key value to check against.
    */
    equals(other: any): boolean;
}
