import * as React from 'react';
import { ListPanel } from './ListPanel';
import { IDataSource } from "igniteui-react-core";
import { IgrListPanelTemplateItemUpdatingEventArgs } from './igr-list-panel-template-item-updating-event-args';
import { ListPanelOrientation } from './ListPanelOrientation';
import { IgrListPanelContentRefreshedEventArgs } from './igr-list-panel-content-refreshed-event-args';
import { IgrListPanelTemplateWidthRequestedEventArgs } from './igr-list-panel-template-width-requested-event-args';
import { IgrListPanelTemplateHeightRequestedEventArgs } from './igr-list-panel-template-height-requested-event-args';
import { IExternalListPanel } from './IExternalListPanel';
export declare class IgrListPanel extends React.Component<IIgrListPanelProps> implements IExternalListPanel {
    private _implementation;
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _portalManager;
    createLocalDataSource(itemsSource: any, schemaIncludedProperties: string[]): IDataSource;
    onContentSizeChanged(): void;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
    }, any>;
    private verifyReferences;
    constructor(props: IIgrListPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): ListPanel;
    get i(): ListPanel;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get rowHeight(): number;
    set rowHeight(v: number);
    get actualRowHeight(): number;
    set actualRowHeight(v: number);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    get hasUnevenSizes(): boolean;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ListPanelOrientation;
    set orientation(v: ListPanelOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get isCustomRowHeightEnabled(): boolean;
    set isCustomRowHeightEnabled(v: boolean);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Gets the last visible index in the grid.

*/
    getLastVisibleIndex(): number;
    /**
     * Gets the first visible index in the grid.
    
    */
    getFirstVisibleIndex(): number;
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    invalidateVisibleItems(): void;
    notifySetItem(index: number, oldItem: any, newItem: any): void;
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems(): void;
    notifyInsertItem(index: number, newItem: any): void;
    notifyRemoveItem(index: number, oldItem: any): void;
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    dataIndexOfItem(item: any): number;
    dataIndexOfPrimaryKey(key: any[]): number;
    exportVisualData(): any;
    exportSerializedVisualData(): string;
    private _contentRefreshed;
    private _contentRefreshed_wrapped;
    get contentRefreshed(): (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void;
    set contentRefreshed(ev: (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void);
    private _rowUpdating;
    private _rowUpdating_wrapped;
    get rowUpdating(): (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void;
    set rowUpdating(ev: (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void);
    private _itemWidthRequested;
    private _itemWidthRequested_wrapped;
    get itemWidthRequested(): (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void;
    set itemWidthRequested(ev: (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void);
    private _itemHeightRequested;
    private _itemHeightRequested_wrapped;
    get itemHeightRequested(): (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void;
    set itemHeightRequested(ev: (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void);
}
export interface IIgrListPanelProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    dataSource?: any;
    /**
 * Gets or Sets the property name that contains the values.
*/
    rowHeight?: number | string;
    actualRowHeight?: number | string;
    /**
     * Gets or Sets the property name that contains the values.
    */
    cellTextStyle?: string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    orientation?: ListPanelOrientation | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    isCustomRowHeightEnabled?: boolean | string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
    contentRefreshed?: (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void;
    rowUpdating?: (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void;
    itemWidthRequested?: (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void;
    itemHeightRequested?: (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void;
}
