import * as React from 'react';
import { PropertyEditorValueType } from "./PropertyEditorValueType";
import { IgrPropertyEditorDescriptionObject } from "./igr-property-editor-description-object";
import { IgrPropertyEditorDescriptionObjectCollection } from "./igr-property-editor-description-object-collection";
import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { IgrPropertyEditorPropertyDescriptionButtonClickEventArgs } from "./igr-property-editor-property-description-button-click-event-args";
import { IgrPropertyEditorPropertyDescriptionChangedEventArgs } from "./igr-property-editor-property-description-changed-event-args";
import { IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./igr-property-editor-property-description-target-property-updating-event-args";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrPropertyEditorPropertyDescription<P extends IIgrPropertyEditorPropertyDescriptionProps = IIgrPropertyEditorPropertyDescriptionProps> extends React.Component<P, {}> {
    protected createImplementation(): PropertyEditorPropertyDescription;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): PropertyEditorPropertyDescription; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrPropertyEditorPropertyDescription;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    get propertyPath(): string;
    set propertyPath(v: string);
    get label(): string;
    set label(v: string);
    get valueType(): PropertyEditorValueType;
    set valueType(v: PropertyEditorValueType);
    get propertyDescriptionType(): string;
    set propertyDescriptionType(v: string);
    get shouldOverrideDefaultEditor(): boolean;
    set shouldOverrideDefaultEditor(v: boolean);
    get elementDescriptionType(): string;
    set elementDescriptionType(v: string);
    get dropDownNames(): string[];
    set dropDownNames(v: string[]);
    get dropDownValues(): string[];
    set dropDownValues(v: string[]);
    get primitiveValue(): any;
    set primitiveValue(v: any);
    get min(): number;
    set min(v: number);
    get editorWidth(): number;
    set editorWidth(v: number);
    get labelWidth(): number;
    set labelWidth(v: number);
    get max(): number;
    set max(v: number);
    get step(): number;
    set step(v: number);
    get complexValue(): IgrPropertyEditorDescriptionObject;
    set complexValue(v: IgrPropertyEditorDescriptionObject);
    private _complexValues;
    get complexValues(): IgrPropertyEditorDescriptionObjectCollection;
    set complexValues(v: IgrPropertyEditorDescriptionObjectCollection);
    private _properties;
    get properties(): IgrPropertyEditorPropertyDescriptionCollection;
    set properties(v: IgrPropertyEditorPropertyDescriptionCollection);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _buttonClicked;
    private _buttonClicked_wrapped;
    get buttonClicked(): (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    set buttonClicked(ev: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionButtonClickEventArgs) => void);
    private _changed;
    private _changed_wrapped;
    get changed(): (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionChangedEventArgs) => void;
    set changed(ev: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionChangedEventArgs) => void);
    private _targetPropertyUpdating;
    private _targetPropertyUpdating_wrapped;
    get targetPropertyUpdating(): (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
    set targetPropertyUpdating(ev: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void);
}
export interface IIgrPropertyEditorPropertyDescriptionProps {
    children?: React.ReactNode;
    propertyPath?: string;
    label?: string;
    valueType?: PropertyEditorValueType | string;
    propertyDescriptionType?: string;
    shouldOverrideDefaultEditor?: boolean | string;
    elementDescriptionType?: string;
    dropDownNames?: string[];
    dropDownValues?: string[];
    primitiveValue?: any;
    min?: number | string;
    editorWidth?: number | string;
    labelWidth?: number | string;
    max?: number | string;
    step?: number | string;
    complexValue?: IgrPropertyEditorDescriptionObject;
    complexValues?: IgrPropertyEditorDescriptionObjectCollection | string;
    properties?: IgrPropertyEditorPropertyDescriptionCollection | string;
    buttonClicked?: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    changed?: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionChangedEventArgs) => void;
    targetPropertyUpdating?: (s: IgrPropertyEditorPropertyDescription, e: IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
}
