import { ToolActionButtonDisplayType } from "./ToolActionButtonDisplayType";
import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionButton } from "./ToolActionButton";
export declare class IgrToolActionButton extends IgrToolAction<IIgrToolActionButtonProps> {
    protected createImplementation(): ToolActionButton;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionButton;
    constructor(props: IIgrToolActionButtonProps);
    /**
     * Gets or sets the display type for the button.
    */
    get displayType(): ToolActionButtonDisplayType;
    set displayType(v: ToolActionButtonDisplayType);
    /**
     * Gets or sets the button corner radius.
    */
    get cornerRadius(): number;
    set cornerRadius(v: number);
}
export interface IIgrToolActionButtonProps extends IIgrToolActionProps {
    /**
     * Gets or sets the display type for the button.
    */
    displayType?: ToolActionButtonDisplayType | string;
    /**
     * Gets or sets the button corner radius.
    */
    cornerRadius?: number | string;
}
