import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
export declare class IgrToolActionIconButton<P extends IIgrToolActionIconButtonProps = IIgrToolActionIconButtonProps> extends IgrToolAction<P> {
    protected createImplementation(): ToolActionIconButton;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionIconButton;
    constructor(props: P);
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    get tooltipDelay(): number;
    set tooltipDelay(v: number);
    /**
     * Gets the actual delay before the tooltip is displayed (in milliseconds).
    */
    get actualTooltipDelay(): number;
    set actualTooltipDelay(v: number);
    get contentPaddingLeft(): number;
    set contentPaddingLeft(v: number);
    get actualContentPaddingLeft(): number;
    set actualContentPaddingLeft(v: number);
    get contentPaddingTop(): number;
    set contentPaddingTop(v: number);
    get actualContentPaddingTop(): number;
    set actualContentPaddingTop(v: number);
    get contentPaddingRight(): number;
    set contentPaddingRight(v: number);
    get actualContentPaddingRight(): number;
    set actualContentPaddingRight(v: number);
    get contentPaddingBottom(): number;
    set contentPaddingBottom(v: number);
    get actualContentPaddingBottom(): number;
    set actualContentPaddingBottom(v: number);
    cleanUp(): void;
    openSubMenu(): void;
    closeSubmenu(): void;
    exportVisualData(): any;
}
export interface IIgrToolActionIconButtonProps extends IIgrToolActionProps {
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    tooltipDelay?: number | string;
    /**
     * Gets the actual delay before the tooltip is displayed (in milliseconds).
    */
    actualTooltipDelay?: number | string;
    contentPaddingLeft?: number | string;
    actualContentPaddingLeft?: number | string;
    contentPaddingTop?: number | string;
    actualContentPaddingTop?: number | string;
    contentPaddingRight?: number | string;
    actualContentPaddingRight?: number | string;
    contentPaddingBottom?: number | string;
    actualContentPaddingBottom?: number | string;
}
