import { IgrToolActionIconButton, IIgrToolActionIconButtonProps } from "./igr-tool-action-icon-button";
import { ToolActionIconMenu } from "./ToolActionIconMenu";
export declare class IgrToolActionIconMenu<P extends IIgrToolActionIconMenuProps = IIgrToolActionIconMenuProps> extends IgrToolActionIconButton<P> {
    protected createImplementation(): ToolActionIconMenu;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionIconMenu;
    constructor(props: P);
    /**
     * Gets or sets the stroke color of the arrow icon.
    */
    get arrowStroke(): string;
    set arrowStroke(v: string);
    /**
     * Gets the actual stroke color of the arrow icon.
    */
    get actualArrowStroke(): string;
    set actualArrowStroke(v: string);
    /**
     * Gets or sets whether the arrow icon should be shown.
    */
    get showArrowIcon(): boolean;
    set showArrowIcon(v: boolean);
    exportVisualData(): any;
}
export interface IIgrToolActionIconMenuProps extends IIgrToolActionIconButtonProps {
    /**
     * Gets or sets the stroke color of the arrow icon.
    */
    arrowStroke?: string;
    /**
     * Gets the actual stroke color of the arrow icon.
    */
    actualArrowStroke?: string;
    /**
     * Gets or sets whether the arrow icon should be shown.
    */
    showArrowIcon?: boolean | string;
}
