import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionRadio } from "./ToolActionRadio";
export declare class IgrToolActionRadio extends IgrToolAction<IIgrToolActionRadioProps> {
    protected createImplementation(): ToolActionRadio;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionRadio;
    constructor(props: IIgrToolActionRadioProps);
    /**
     * Gets or sets the channel this radio button belongs to.
    */
    get channel(): string;
    set channel(v: string);
    /**
     * Gets or sets if the tool action is checked.
    */
    get isChecked(): boolean;
    set isChecked(v: boolean);
    /**
     * Gets or sets if the checked state of the radio is handled manually by the user. The radio
     * well not become selected when clicked if this property is true.
    */
    get isManual(): boolean;
    set isManual(v: boolean);
    /**
     * Gets or sets the background color of the radio when in the unchecked state.
    */
    get uncheckedBackgroundColor(): string;
    set uncheckedBackgroundColor(v: string);
    /**
     * Gets the actual background color of the radio when in the unchecked state.
    */
    get actualUncheckedBackgroundColor(): string;
    set actualUncheckedBackgroundColor(v: string);
    /**
     * Gets or sets the background color of the radio when in the checked state.
    */
    get checkedBackgroundColor(): string;
    set checkedBackgroundColor(v: string);
    /**
     * Gets the actual background color of the radio when in the checked state.
    */
    get actualCheckedBackgroundColor(): string;
    set actualCheckedBackgroundColor(v: string);
    /**
     * Gets or sets the border color of the radio when in the unchecked state.
    */
    get uncheckedBorderColor(): string;
    set uncheckedBorderColor(v: string);
    /**
     * Gets the actual border color of the radio when in the unchecked state.
    */
    get actualUncheckedBorderColor(): string;
    set actualUncheckedBorderColor(v: string);
    /**
     * Gets or sets the border color of the radio when in the checked state.
    */
    get checkedBorderColor(): string;
    set checkedBorderColor(v: string);
    /**
     * Gets the actual border color of the radio when in the checked state.
    */
    get actualCheckedBorderColor(): string;
    set actualCheckedBorderColor(v: string);
}
export interface IIgrToolActionRadioProps extends IIgrToolActionProps {
    /**
     * Gets or sets the channel this radio button belongs to.
    */
    channel?: string;
    /**
     * Gets or sets if the tool action is checked.
    */
    isChecked?: boolean | string;
    /**
     * Gets or sets if the checked state of the radio is handled manually by the user. The radio
     * well not become selected when clicked if this property is true.
    */
    isManual?: boolean | string;
    /**
     * Gets or sets the background color of the radio when in the unchecked state.
    */
    uncheckedBackgroundColor?: string;
    /**
     * Gets the actual background color of the radio when in the unchecked state.
    */
    actualUncheckedBackgroundColor?: string;
    /**
     * Gets or sets the background color of the radio when in the checked state.
    */
    checkedBackgroundColor?: string;
    /**
     * Gets the actual background color of the radio when in the checked state.
    */
    actualCheckedBackgroundColor?: string;
    /**
     * Gets or sets the border color of the radio when in the unchecked state.
    */
    uncheckedBorderColor?: string;
    /**
     * Gets the actual border color of the radio when in the unchecked state.
    */
    actualUncheckedBorderColor?: string;
    /**
     * Gets or sets the border color of the radio when in the checked state.
    */
    checkedBorderColor?: string;
    /**
     * Gets the actual border color of the radio when in the checked state.
    */
    actualCheckedBorderColor?: string;
}
