import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionSeparator } from "./ToolActionSeparator";
export declare class IgrToolActionSeparator extends IgrToolAction<IIgrToolActionSeparatorProps> {
    protected createImplementation(): ToolActionSeparator;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionSeparator;
    constructor(props: IIgrToolActionSeparatorProps);
    /**
     * Gets or sets the size of the separator.
    */
    get size(): number;
    set size(v: number);
    /**
     * Gets or sets whether to use group header styling or regular styling on this separator.
    */
    get isGroupHeaderSeparator(): boolean;
    set isGroupHeaderSeparator(v: boolean);
}
export interface IIgrToolActionSeparatorProps extends IIgrToolActionProps {
    /**
     * Gets or sets the size of the separator.
    */
    size?: number | string;
    /**
     * Gets or sets whether to use group header styling or regular styling on this separator.
    */
    isGroupHeaderSeparator?: boolean | string;
}
