import * as React from 'react';
import { IgSize } from "igniteui-react-core";
import { Toolbar } from './Toolbar';
import { BaseControlTheme } from "igniteui-react-core";
import { ToolbarOrientation } from './ToolbarOrientation';
import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolAction } from './igr-tool-action';
import { IgrToolCommandEventArgs } from './igr-tool-command-event-args';
import { ToolCommandStateType } from "igniteui-react-core";
export declare class IgrToolbar extends React.Component<IIgrToolbarProps> {
    private _implementation;
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _portalManager;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    private _contentChildrenManager;
    private _updateContentChildren;
    contentActions: IgrToolAction[];
    /**
    * The style mappings actually present in the treemap. Do not directly modify this array.
    * This array's contents can be modified by causing React to reproject the child content.
    * Or adding and removing ranges from the manual ranges collection on the ranges property.
    */
    combinedActions: IgrToolAction[];
    private _actions;
    private _actionsAdapter;
    /**
     * A collection of manually added style mappings for the treemap.
    */
    get actions(): IgrToolActionCollection;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
        children: any[];
    }, any>;
    private verifyReferences;
    private requestRender;
    constructor(props: IIgrToolbarProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): Toolbar;
    get i(): Toolbar;
    /**
     * Gets or sets a target component which the toolbar can request actions from.
     */
    get target(): any;
    set target(v: any);
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    private _autoGeneratedActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get autoGeneratedActions(): IgrToolActionCollection;
    set autoGeneratedActions(v: IgrToolActionCollection);
    private _actualActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get actualActions(): IgrToolActionCollection;
    set actualActions(v: IgrToolActionCollection);
    /**
     * Gets or sets the orientation of the toolbar.
    */
    get orientation(): ToolbarOrientation;
    set orientation(v: ToolbarOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the background color for submenus.
    */
    get submenuBackgroundColor(): string;
    set submenuBackgroundColor(v: string);
    /**
     * Gets or sets the group header background color.
    */
    get groupHeaderBackgroundColor(): string;
    set groupHeaderBackgroundColor(v: string);
    /**
     * Gets or sets the separator background color.
    */
    get separatorBackgroundColor(): string;
    set separatorBackgroundColor(v: string);
    /**
     * Gets or sets the hover background color.
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the text in disabled tool actions.
    */
    get disabledTextColor(): string;
    set disabledTextColor(v: string);
    /**
     * Gets or sets the text color for group header tool actions.
    */
    get groupHeaderTextColor(): string;
    set groupHeaderTextColor(v: string);
    /**
     * Gets or sets the tooltip text color.
    */
    get toolTipTextColor(): string;
    set toolTipTextColor(v: string);
    /**
     * Gets or sets the tooltip background color.
    */
    get toolTipBackgroundColor(): string;
    set toolTipBackgroundColor(v: string);
    /**
     * Gets or sets the tooltip corner radius.
    */
    get toolTipCornerRadius(): number;
    set toolTipCornerRadius(v: number);
    /**
     * Gets or sets the shadow elevation for the tooltip.
    */
    get toolTipElevation(): number;
    set toolTipElevation(v: number);
    /**
     * Gets or sets the fill color of icons in the ToolPanel.
    */
    get iconFill(): string;
    set iconFill(v: string);
    /**
     * Gets or sets the stroke color of icons in the ToolPanel.
    */
    get iconStroke(): string;
    set iconStroke(v: string);
    /**
     * Gets or sets the text style.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    /**
     * Gets or sets the text style for subtitles.
    */
    get subtitleTextStyle(): string;
    set subtitleTextStyle(v: string);
    /**
     * Gets or sets the left padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingLeft(): number;
    set separatorVerticalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingRight(): number;
    set separatorVerticalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingTop(): number;
    set separatorVerticalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingBottom(): number;
    set separatorVerticalPaddingBottom(v: number);
    /**
     * Gets or sets the left padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingLeft(): number;
    set separatorHorizontalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingRight(): number;
    set separatorHorizontalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingTop(): number;
    set separatorHorizontalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingBottom(): number;
    set separatorHorizontalPaddingBottom(v: number);
    /**
     * Gets or sets if the tool actions should display their submenus on mouse hover.
    */
    get showOnHover(): boolean;
    set showOnHover(v: boolean);
    get highlightWidth(): number;
    set highlightWidth(v: number);
    get highlightRadius(): number;
    set highlightRadius(v: number);
    get highlightColor(): string;
    set highlightColor(v: string);
    /**
     * Gets or sets the stroke color for all icon menu dropdown arrows.
    */
    get menuArrowStroke(): string;
    set menuArrowStroke(v: string);
    /**
     * Gets or sets the background color of the radio when in the unchecked state.
    */
    get uncheckedBackgroundColor(): string;
    set uncheckedBackgroundColor(v: string);
    /**
     * Gets or sets the background color of the radio when in the checked state.
    */
    get checkedBackgroundColor(): string;
    set checkedBackgroundColor(v: string);
    /**
     * Gets or sets the border color of the radio when in the unchecked state.
    */
    get uncheckedBorderColor(): string;
    set uncheckedBorderColor(v: string);
    /**
     * Gets or sets the border color of the radio when in the checked state.
    */
    get checkedBorderColor(): string;
    set checkedBorderColor(v: string);
    /**
     * Gets or sets the row height that should be used.
    */
    get rowHeight(): number;
    set rowHeight(v: number);
    /**
     * Gets or sets the text color for subtitles.
    */
    get subtitleTextColor(): string;
    set subtitleTextColor(v: string);
    /**
     * Gets or sets the text color for group header subtitles.
    */
    get groupHeaderSubtitleTextColor(): string;
    set groupHeaderSubtitleTextColor(v: string);
    /**
     * Gets or sets the dropdown delay time in milliseconds.
    */
    get dropdownDelay(): number;
    set dropdownDelay(v: number);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Get the desired size the toolbar wants to be.

*/
    getDesiredSize(): IgSize;
    /**
     * Forces any open sub menus to close.
    
    */
    closeSubmenus(): void;
    onCommandStateChanged(id: string, type: ToolCommandStateType, value: any): void;
    registerIconFromText(iconCollection: string, iconName: string, iconText: string): void;
    getIconFromCache(iconCollection: string, iconName: string): string;
    registerMultiPathSVG(iconCollection: string, iconName: string, multiPathSVG: string[]): void;
    getMultiPathSVGFromCache(iconCollection: string, iconName: string): string[];
    setContextItem(key: string, value: any): void;
    getContextItem(key: string): any;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualData(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualData(): string;
    private _onCommand;
    private _onCommand_wrapped;
    /**
     * Event raised when a command is triggered in the toolbar.
    */
    get onCommand(): (s: IgrToolbar, e: IgrToolCommandEventArgs) => void;
    set onCommand(ev: (s: IgrToolbar, e: IgrToolCommandEventArgs) => void);
}
export interface IIgrToolbarProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    actions?: IgrToolActionCollection;
    target?: any;
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    autoGeneratedActions?: IgrToolActionCollection | string;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    actualActions?: IgrToolActionCollection | string;
    /**
     * Gets or sets the orientation of the toolbar.
    */
    orientation?: ToolbarOrientation | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the background color for submenus.
    */
    submenuBackgroundColor?: string;
    /**
     * Gets or sets the group header background color.
    */
    groupHeaderBackgroundColor?: string;
    /**
     * Gets or sets the separator background color.
    */
    separatorBackgroundColor?: string;
    /**
     * Gets or sets the hover background color.
    */
    hoverBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
    /**
     * Gets or sets the color to use for the text in disabled tool actions.
    */
    disabledTextColor?: string;
    /**
     * Gets or sets the text color for group header tool actions.
    */
    groupHeaderTextColor?: string;
    /**
     * Gets or sets the tooltip text color.
    */
    toolTipTextColor?: string;
    /**
     * Gets or sets the tooltip background color.
    */
    toolTipBackgroundColor?: string;
    /**
     * Gets or sets the tooltip corner radius.
    */
    toolTipCornerRadius?: number | string;
    /**
     * Gets or sets the shadow elevation for the tooltip.
    */
    toolTipElevation?: number | string;
    /**
     * Gets or sets the fill color of icons in the ToolPanel.
    */
    iconFill?: string;
    /**
     * Gets or sets the stroke color of icons in the ToolPanel.
    */
    iconStroke?: string;
    /**
     * Gets or sets the text style.
    */
    cellTextStyle?: string;
    /**
     * Gets or sets the text style for subtitles.
    */
    subtitleTextStyle?: string;
    /**
     * Gets or sets the left padding for separators in the vertical orientation.
    */
    separatorVerticalPaddingLeft?: number | string;
    /**
     * Gets or sets the right padding for separators in the vertical orientation.
    */
    separatorVerticalPaddingRight?: number | string;
    /**
     * Gets or sets the top padding for separators in the vertical orientation.
    */
    separatorVerticalPaddingTop?: number | string;
    /**
     * Gets or sets the bottom padding for separators in the vertical orientation.
    */
    separatorVerticalPaddingBottom?: number | string;
    /**
     * Gets or sets the left padding for separators in the horizontal orientation.
    */
    separatorHorizontalPaddingLeft?: number | string;
    /**
     * Gets or sets the right padding for separators in the horizontal orientation.
    */
    separatorHorizontalPaddingRight?: number | string;
    /**
     * Gets or sets the top padding for separators in the horizontal orientation.
    */
    separatorHorizontalPaddingTop?: number | string;
    /**
     * Gets or sets the bottom padding for separators in the horizontal orientation.
    */
    separatorHorizontalPaddingBottom?: number | string;
    /**
     * Gets or sets if the tool actions should display their submenus on mouse hover.
    */
    showOnHover?: boolean | string;
    highlightWidth?: number | string;
    highlightRadius?: number | string;
    highlightColor?: string;
    /**
     * Gets or sets the stroke color for all icon menu dropdown arrows.
    */
    menuArrowStroke?: string;
    /**
     * Gets or sets the background color of the radio when in the unchecked state.
    */
    uncheckedBackgroundColor?: string;
    /**
     * Gets or sets the background color of the radio when in the checked state.
    */
    checkedBackgroundColor?: string;
    /**
     * Gets or sets the border color of the radio when in the unchecked state.
    */
    uncheckedBorderColor?: string;
    /**
     * Gets or sets the border color of the radio when in the checked state.
    */
    checkedBorderColor?: string;
    /**
     * Gets or sets the row height that should be used.
    */
    rowHeight?: number | string;
    /**
     * Gets or sets the text color for subtitles.
    */
    subtitleTextColor?: string;
    /**
     * Gets or sets the text color for group header subtitles.
    */
    groupHeaderSubtitleTextColor?: string;
    /**
     * Gets or sets the dropdown delay time in milliseconds.
    */
    dropdownDelay?: number | string;
    /**
 * Event raised when a command is triggered in the toolbar.
*/
    onCommand?: (s: IgrToolbar, e: IgrToolCommandEventArgs) => void;
}
