import * as React from 'react';
import { XExpansionPanel } from './XExpansionPanel';
import { IgrOnExpandedEventArgs } from './igr-on-expanded-event-args';
import { IgrOnCollapsedEventArgs } from './igr-on-collapsed-event-args';
export declare class IgrXExpansionPanel extends React.Component<IIgrXExpansionPanelProps> {
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _headerRef;
    private _contentAreaOuterRef;
    private _contentAreaInnerRef;
    private _reactRenderer;
    private _implementation;
    private _portalManager;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    private _getHeaderRef;
    private _getContentAreaOuterRef;
    private _getContentAreaInnerRef;
    private verifyReferences;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
        children: any[];
    }, any>;
    private requestRender;
    constructor(props: IIgrXExpansionPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): XExpansionPanel;
    get i(): XExpansionPanel;
    /**
 * Gets / sets the caption to display in the header area.
*/
    get caption(): string;
    set caption(v: string);
    /**
     * Gets or sets the color to use for the header caption text.
    */
    get captionTextColor(): string;
    set captionTextColor(v: string);
    /**
     * Gets or sets the color to use for the actual header caption text.
    */
    get actualCaptionTextColor(): string;
    set actualCaptionTextColor(v: string);
    /**
     * Gets or sets the color to use for the header caption text when the panel is collapsed.
    */
    get captionCollapsedTextColor(): string;
    set captionCollapsedTextColor(v: string);
    /**
     * Gets or sets the color to use for the header caption text when the panel is expanded.
    */
    get captionExpandedTextColor(): string;
    set captionExpandedTextColor(v: string);
    /**
     * Gets / sets the description to display in the header area.
    */
    get description(): string;
    set description(v: string);
    /**
     * Gets or sets the color to use for the header description text.
    */
    get descriptionTextColor(): string;
    set descriptionTextColor(v: string);
    /**
     * Gets or sets the color to use for the actual header description text.
    */
    get actualDescriptionTextColor(): string;
    set actualDescriptionTextColor(v: string);
    /**
     * Gets or sets the color to use for the header description text when the panel is collapsed.
    */
    get descriptionCollapsedTextColor(): string;
    set descriptionCollapsedTextColor(v: string);
    /**
     * Gets or sets the color to use for the header description text when the panel is expanded.
    */
    get descriptionExpandedTextColor(): string;
    set descriptionExpandedTextColor(v: string);
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    get elevation(): number;
    set elevation(v: number);
    /**
     * Gets or sets the elevation of the border shadow
    */
    get actualElevation(): number;
    set actualElevation(v: number);
    /**
     * Gets / sets the expanded state of the panel.
    */
    get expanded(): boolean;
    set expanded(v: boolean);
    /**
     * Gets or sets the color to use for the background of the header.
    */
    get headerBackgroundColor(): string;
    set headerBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the actual background of the header.
    */
    get actualHeaderBackgroundColor(): string;
    set actualHeaderBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    get headerCollapsedBackgroundColor(): string;
    set headerCollapsedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    get headerExpandedBackgroundColor(): string;
    set headerExpandedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUmbraShadowColor(): string;
    set actualUmbraShadowColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualPenumbraShadowColor(): string;
    set actualPenumbraShadowColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualAmbientShadowColor(): string;
    set actualAmbientShadowColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Collapses the contents of the expansion panel.

*/
    collapse(): void;
    /**
     * Expands the contents of the expansion panel.
    
    */
    expand(): void;
    /**
     * Toggles the expanded state of the expansion panel.
    
    */
    toggle(): void;
    private _onCollapsed;
    private _onCollapsed_wrapped;
    /**
     * Fires when the expansion panel is collapsed.
    */
    get onCollapsed(): (s: IgrXExpansionPanel, e: IgrOnCollapsedEventArgs) => void;
    set onCollapsed(ev: (s: IgrXExpansionPanel, e: IgrOnCollapsedEventArgs) => void);
    private _onExpanded;
    private _onExpanded_wrapped;
    get onExpanded(): (s: IgrXExpansionPanel, e: IgrOnExpandedEventArgs) => void;
    set onExpanded(ev: (s: IgrXExpansionPanel, e: IgrOnExpandedEventArgs) => void);
}
export interface IIgrXExpansionPanelProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    /**
 * Gets / sets the caption to display in the header area.
*/
    caption?: string;
    /**
     * Gets or sets the color to use for the header caption text.
    */
    captionTextColor?: string;
    /**
     * Gets or sets the color to use for the actual header caption text.
    */
    actualCaptionTextColor?: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is collapsed.
    */
    captionCollapsedTextColor?: string;
    /**
     * Gets or sets the color to use for the header caption text when the panel is expanded.
    */
    captionExpandedTextColor?: string;
    /**
     * Gets / sets the description to display in the header area.
    */
    description?: string;
    /**
     * Gets or sets the color to use for the header description text.
    */
    descriptionTextColor?: string;
    /**
     * Gets or sets the color to use for the actual header description text.
    */
    actualDescriptionTextColor?: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is collapsed.
    */
    descriptionCollapsedTextColor?: string;
    /**
     * Gets or sets the color to use for the header description text when the panel is expanded.
    */
    descriptionExpandedTextColor?: string;
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    elevation?: number | string;
    /**
     * Gets or sets the elevation of the border shadow
    */
    actualElevation?: number | string;
    /**
     * Gets / sets the expanded state of the panel.
    */
    expanded?: boolean | string;
    /**
     * Gets or sets the color to use for the background of the header.
    */
    headerBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the actual background of the header.
    */
    actualHeaderBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerCollapsedBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    headerExpandedBackgroundColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualUmbraShadowColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualPenumbraShadowColor?: string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    actualAmbientShadowColor?: string;
    /**
 * Fires when the expansion panel is collapsed.
*/
    onCollapsed?: (s: IgrXExpansionPanel, e: IgrOnCollapsedEventArgs) => void;
    onExpanded?: (s: IgrXExpansionPanel, e: IgrOnExpandedEventArgs) => void;
}
